using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Text;
using SubSystems.WP;             // DOC/DOCX to PDF Converter

namespace Demo
{
    /// <summary>
    /// Summary description for demo.
    /// </summary>

    public class Demo : System.Windows.Forms.Form
    {

        ///////////////////////
        // OPTIONS VARIABLES //
        ///////////////////////

        OptionsState OptState;
        bool OptionsButtonPressed = false;

        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox InputFile;
        private System.Windows.Forms.TextBox OutputFile;
        private System.Windows.Forms.CheckBox UseBuffer;
        private System.Windows.Forms.Label Status;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Button OK;
        private System.Windows.Forms.Button Cancel;
        private System.Windows.Forms.Button Options; // 04 01 2020
        private System.Windows.Forms.LinkLabel Purchase;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        ///////////////////////////////////////////////////////////////////////////////////////////////////
        ///    Constructor
        ///////////////////////////////////////////////////////////////////////////////////////////////////
        public Demo()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.OptState = new OptionsState(); // 02 01 2020

            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.InputFile = new System.Windows.Forms.TextBox();
            this.OutputFile = new System.Windows.Forms.TextBox();
            this.UseBuffer = new System.Windows.Forms.CheckBox();
            this.Status = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.OK = new System.Windows.Forms.Button();
            this.Cancel = new System.Windows.Forms.Button();
            this.Options = new System.Windows.Forms.Button(); // 04 01 2020
            this.Purchase = new System.Windows.Forms.LinkLabel();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            //
            // label1
            //
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(184, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "Input File Name (.doc, .docx)";
            //
            // label2
            //
            this.label2.Location = new System.Drawing.Point(8, 64);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(192, 16);
            this.label2.TabIndex = 1;
            this.label2.Text = "Output File Name (.pdf)";
            //
            // InputFile
            //
            this.InputFile.Location = new System.Drawing.Point(8, 32);
            this.InputFile.Name = "InputFile";
            this.InputFile.Size = new System.Drawing.Size(320, 20);
            this.InputFile.TabIndex = 2;
            this.InputFile.Text = "";
            //
            // OutputFile
            //
            this.OutputFile.Location = new System.Drawing.Point(8, 80);
            this.OutputFile.Name = "OutputFile";
            this.OutputFile.Size = new System.Drawing.Size(320, 20);
            this.OutputFile.TabIndex = 3;
            this.OutputFile.Text = "";
            //
            // UseBuffer
            //
            this.UseBuffer.Location = new System.Drawing.Point(8, 120);
            this.UseBuffer.Name = "UseBuffer";
            this.UseBuffer.Size = new System.Drawing.Size(184, 16);
            this.UseBuffer.TabIndex = 6;
            this.UseBuffer.Text = "Transfer file as buffer";
            //
            // Status
            //
            this.Status.Location = new System.Drawing.Point(208, 120);
            this.Status.Name = "Status";
            this.Status.Size = new System.Drawing.Size(120, 16);
            this.Status.TabIndex = 7;
            this.Status.TextAlign = System.Drawing.ContentAlignment.TopRight;
            //
            // groupBox1
            //
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.InputFile);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.UseBuffer);
            this.groupBox1.Controls.Add(this.OutputFile);
            this.groupBox1.Controls.Add(this.Status);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(336, 144);
            this.groupBox1.TabIndex = 8;
            this.groupBox1.TabStop = false;
            //
            // Options 04 01 2020
            //
            this.Options.Location = new System.Drawing.Point(112, 160);
            this.Options.Name = "Options";
            this.Options.TabIndex = 9;
            this.Options.Text = "Options";
            this.Options.Click += new System.EventHandler(this.Options_Click);
            //
            // OK
            //
            this.OK.Location = new System.Drawing.Point(272, 160);
            this.OK.Name = "OK";
            this.OK.TabIndex = 11;
            this.OK.Text = "OK";
            this.OK.Click += new System.EventHandler(this.OK_Click);
            //
            // Cancel
            //
            this.Cancel.Location = new System.Drawing.Point(192, 160);
            this.Cancel.Name = "Cancel";
            this.Cancel.TabIndex = 10;
            this.Cancel.Text = "Cancel";
            // TODO make this work! (default close operation, could use dispose)
            //
            // Purchase
            //
            this.Purchase.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Purchase.LinkArea = new System.Windows.Forms.LinkArea(0, 0);
            this.Purchase.Location = new System.Drawing.Point(8, 160);
            this.Purchase.Name = "Purchase";
            this.Purchase.Size = new System.Drawing.Size(80, 16);
            this.Purchase.TabIndex = 12;
            this.Purchase.Text = "Purchase...";
            this.Purchase.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.Purchase_LinkClicked);
            //
            // Demo
            //
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.Cancel;
            this.AcceptButton = this.OK;
            this.ClientSize = new System.Drawing.Size(352, 189);
            this.Controls.Add(this.Purchase);
            this.Controls.Add(this.Options); // 04 01 2020
            this.Controls.Add(this.Cancel);
            this.Controls.Add(this.OK);
            this.Controls.Add(this.groupBox1);
            this.Name = "Demo";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "DOC/DOCX to PDF Converter Demo";
            this.Load += new System.EventHandler(this.Demo_Load);
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Demo());
        }

        protected override void OnPaintBackground(System.Windows.Forms.PaintEventArgs ev)
        {
            base.OnPaintBackground(ev);
        }

        private void Demo_Load(object sender, System.EventArgs e) {
            Purchase.Links.Add(0, 11, "www.subsystems.com/wpw.htm");
            //DemoTest1();   // test code
        }

        private void OK_Click(object sender, System.EventArgs e) {
            bool result = false;

            Status.Text = "";

            string InFile = InputFile.Text;
            string OutFile = OutputFile.Text;

            // check the file names
            if (InFile.Length == 0) {
                InputFile.Focus();
                return;
            }
            if (OutFile.Length == 0) {
                OutputFile.Focus();
                return;
            }

            Status.Text = "Converting...";
            Status.Refresh();

            // do the conversion
            Wpn wpn = new Wpn();

            // TODO TODO TODO look through these and determine which are irrelevant
            // FORMAT

            //wpn.Title="my title";
            //wpn.WpsSetPaperSize(PaperKind.Custom, 12240, 15840);
            //wpn.WpsSetPaperOrient(false);
            //wpn.WpsSetPageMargin(720, 720, 720, 720);
            //wpn.ExpandWidth=true; //expand the width of the output pdf, if necessary, to fit the widest table in the document
            //wpn.WpsSetPageBorder(Wpn.BRDRTYPE_DBL,30,720,Color.Red);
            //wpn.WpsSetRepInfo("[","of","]",360,Wpn.WPREP_BOT|Wpn.WPREP_CENTER); // print page number at the bottom of the page

            // SECURITY

            //wpn.OwnerPassword = "owner";
            //wpn.UserPassword = "user";
            //wpn.AES_128=true;
            //wpn.PermFlags = Wpn.PERM_PRINT; // Wpn.PERM_COPY | Wpn.PERM_MOD;

            // QUALITY

            //wpn.PictQuality=1;        // picture quality, 1=lowest, 5=highest, 3=default
            //wpn.UseOrigJpg=false;     // use original jpeg to produce pdf
            //wpn.EmfAsBmp=true;        // convert emf images to bmp

            // FILE SIZE

            // wpn.CompressText = true; // compress text

            // MISC

            //wpn.InWebServer = true;
            //wpn.DoCaching=false;      // write directly to disk
            //wpn.IsolateUnicode=true;
            //wpn.HideTracking=true;    // hide track-changes text
            //wpn.NoTocUpdate=true;     // true to use the original (un-updated) table-of-content
            //wpn.ClearBknd=false;      // true to clear page-background before drawing (default=true)

            // COMPATIBILITY

            //wpn.MacCompatible=true;
            //wpn.MacCompatible = false;
            // wpn.EmbedFonts = true;
            //wpn.LegacySectProps=true; // restore legacy section properites
            //wpn.PdfA1b=true;          // set pdf-a compliance
            //wpn.PdfA2b=true;          // set pdf-a2b compliance
            //wpn.PdfA=true;            // set pdf-a compliance
            //wpn.PdfUA=true;           // set pdf-ua compliance
            //wpn.PdfA3=true;           // set pdf-a3 compliance
            //wpn.WpsEmbedFile("demo.rtf",null,"rtf file"); // an example of embedding a file for pdf/a3 output
            //wpn.WpsEmbedFile("demo.htm",null,"html file"); // an example of embedding a file for pdf/a3 output

            // PRINTING

            //wpn.NoScaling=true;            // turn-on the no-scaling print-time document property
            //wpn.DuplexShort=true;          // turn-on the short-edge duplex print-time document property
            //wpn.DuplexLong=true;           // turn-on the long-edge duplex print-time document property

            // FORMATTING

            //wpn.ShrinkImagesToFit=true;    // Shrink the RTF images to fit on the page or the table cell
            //wpn.ExactTextPlacement=true;   // trun-on exact text placement
            // wpn.ConvertComboBox = true;   // 20180312: convert combo-box to text to avoid extra space at the right

            // all the code below dealing with options 04 01 2020

            if(OptionsButtonPressed) {
                ApplyDemoOptions(wpn);
            }

            if (UseBuffer.Checked) {  // read the file in the memory buffer and do the conversion
              byte[] InData=null;
              string OutData;
              if ((InData=wpn.WpsFileToBytes(InFile))!=null) {
                if ((OutData=wpn.WpsConvertBuffer(InData))!=null) {
                  result=wpn.WpsWriteToFile(OutFile,OutData); // write the memory to the output file
                }
              }
            }
            else result=wpn.WpsConvertFile(InFile,OutFile);       // convert files directly


            InputFile.Focus(); // ask for the next file
            Status.Text = result ? "Done!" : "Error!";

            if (result) {
                try { System.Diagnostics.Process.Start(OutFile); }  // display pdf
                catch { };
            }
        }

        /**************************************************
            ApplyDemoOptions:
            This method is called if the user clicked on
            'options' button to select the PDF document
            creation properties.
            It assigns the user selected properties to the
            Wpn object before calling the conversion method.
         **************************************************/
        void ApplyDemoOptions(Wpn wpn) {

            if (!OptState.title.Equals("")) {
                wpn.Title = OptState.title;
            }

            if(OptState.paperSizeCustom) {
                wpn.WpsSetPaperSize(PaperKind.Custom, (int)OptState.paperSizeWidth, (int)OptState.paperSizeHeight);
            }

            wpn.WpsSetPaperOrient(OptState.paperOrientIsPortrait);

            if(OptState.setMargins) {
                wpn.WpsSetPageMargin((int)OptState.marginLeft, (int)OptState.marginRight, (int)OptState.marginTop, (int)OptState.marginBottom);
            }

            wpn.ExpandWidth = OptState.expandWidth;

            wpn.OmitLastEmptyPage = OptState.omitLastEmptyPage; // set to true to omit the last page if empty

            if (OptState.hasBorder) {
                wpn.WpsSetPageBorder(OptState.borderType, OptState.borderWidth, OptState.borderSpace, OptState.borderColor);
            }

            if (OptState.printPageNumbers) {
                wpn.WpsSetRepInfo(OptState.beforeText, OptState.midText, OptState.afterText, OptState.distanceFromEdge, OptState.verticalAlignment | OptState.horizontalAlignment);
            }

            if (OptState.hasOwnerPassword) {
                wpn.OwnerPassword = OptState.ownerPassword;
            }
            if (OptState.hasUserPassword) {
                wpn.UserPassword = OptState.userPassword;
            }

            wpn.AES_128 = OptState.usesEncryptionAES128;

            int perm = 0;
            if (OptState.permPrint)  { perm += Wpn.PERM_PRINT; }
            if (OptState.permCopy)   { perm += Wpn.PERM_COPY;  }
            if (OptState.permModify) { perm += Wpn.PERM_MOD;   }
            wpn.PermFlags = perm;

            if (OptState.useOrigJpg) {
                wpn.UseOrigJpg = true;
            } else {
                wpn.PictQuality = OptState.pictQuality;
            }

            wpn.EmfAsBmp = OptState.emfAsBmp;

            wpn.CompressText = OptState.compressText;
            wpn.InWebServer = OptState.inWebServer;
            wpn.DoCaching = OptState.doCaching;
            wpn.IsolateUnicode = OptState.isolateUnicode;
            wpn.HideTracking = OptState.hideTracking;
            wpn.NoTocUpdate = OptState.noTocUpdate;
            wpn.ClearBknd = OptState.clearBackground;
            wpn.HideComments = OptState.hideComments;
            wpn.TaggedPdf = OptState.taggedPdf;

            wpn.EmbedFonts = OptState.embedFonts;

            wpn.LegacySectProps = OptState.legacySectionProperties;

            if (OptState.complianceLevel == OptionsState.CMPL_PDFA1B) { wpn.PdfA1b = true; } else
            if (OptState.complianceLevel == OptionsState.CMPL_PDFA1 ) { wpn.PdfA   = true; } else
            if (OptState.complianceLevel == OptionsState.CMPL_PDFA2B) { wpn.PdfA2b = true; } else
            if (OptState.complianceLevel == OptionsState.CMPL_PDFUA ) { wpn.PdfUA  = true; } else
            if (OptState.complianceLevel == OptionsState.CMPL_PDFA3 ) { wpn.PdfA3  = true; }

            for (int i = 0; i < OptState.embedFiles.Count; i += 2) {
                wpn.WpsEmbedFile((String)OptState.embedFiles[i], null, (String)OptState.embedFiles[i + 1]);
            }

            wpn.NoScaling   = OptState.noScaling;
            wpn.DuplexShort = OptState.duplexShort;
            wpn.DuplexLong  = OptState.duplexLong;

            wpn.ShrinkImagesToFit = OptState.shrinkImagesToFit;
            wpn.ExactTextPlacement = OptState.exactTextPlacement;

            wpn.ConvertComboBox = OptState.convertComboBox;
        }

        private void Purchase_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs ev) {
            // Determine which link was clicked within the LinkLabel.
            Purchase.Links[Purchase.Links.IndexOf(ev.Link)].Visited = true;
            // Display the appropriate link based on the value of the LinkData property of the Link object.
            System.Diagnostics.Process.Start(ev.Link.LinkData.ToString());
        }

        // 04 01 2020
        private void Options_Click(object sender, System.EventArgs e) {
            OptionsForm OptionsFormObj = new OptionsForm(this.OptState);
            OptionsFormObj.ShowDialog();
            OptionsButtonPressed = true;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////  Helper functions
        /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        string ReadFromFile(string file)
        {
            string str = null;

            StreamReader InFile = null;
            if ((InFile = new StreamReader(file)) != null) {
                str = InFile.ReadToEnd();
                InFile.Close();
            }

            return str;
        }

        /////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //    Testing/Debugging code
        /////////////////////////////////////////////////////////////////////////////////////////////////////////////
        /***************************************************************************
            DemoTest1:
            test code
        ****************************************************************************/
        internal new void DemoTest1()
        {

        }

        // convert a byte array containing doc/docx to pdf
        byte[] ConvertBuffer(byte[] DocInputBytes)
        {
          Wpn wp = new Wpn();      // Create the conversion object
          wp.InWebServer = true;   // set to true when hosting the
          string PdfString = wp.WpsConvertBuffer(DocInputBytes);
          return wp.WpsStrToBytes(PdfString);
        }

        /***************************************************************************
            ToInt:
            Convert string to integer
        ****************************************************************************/
        internal new int ToInt(TextBox item)
        {
            return ToInt(item.Text);
        }

        internal new int ToInt(string txt)
        {
            try {
                return (int)Convert.ToInt32(txt);
            }
            catch (System.Exception)
            {
                return 0;
            }
        }

        internal new bool True(int val)
        {
            return (val != 0);
        }

    }

    /**************************************************
        OptionsForm:
        The OptionsForm class holds the entire state of
        the Options button dialog. including all form
        elements.
    **************************************************/
    public class OptionsForm : System.Windows.Forms.Form {

        // designer variable
        private System.ComponentModel.Container components;

        private System.Windows.Forms.Button ApplyButton, CancelBtn;

        // 01192021: splitting tabs to avoid scrolling
        private System.Windows.Forms.TabPage FormatTab, PageTab, SecurityTab, QualityTab, CompatTab, PrintingTab, OtherTab;
        private System.Windows.Forms.TabControl TabControls;

        // tab elements

        private System.Windows.Forms.CheckBox
            PaperSizeCustomCheckBox, MarginCheckBox, BorderCheckBox, PageNumCheckBox, OmitLastEmptyPageCheckBox,
            ExpandWidthCheckBox, ShrinkImagesToFitCheckBox, ExactTextPlacementCheckBox, ConvertComboBoxesCheckBox,
            EncryptCheckBox, OwnerPwdCheckBox, UserPwdCheckBox, PwdUserCanPrintCheckBox, PwdUserCanCopyCheckBox,
            PwdUserCanModifyCheckBox, CompressTextCheckBox, UseOrigJpegsCheckBox, EmfAsBmpCheckBox,
            EmbedFontsCheckBox, LegSecPropCheckBox, NoScalingCheckBox, DuplexShortCheckBox, DuplexLongCheckBox,
            InWebServerCheckBox, DoCachingCheckBox, IsolateUnicodeCheckBox, HideTrackingCheckBox, NoTOCUpdateCheckBox,
            ClearBackgroundCheckBox, HideCommentsCheckBox, TaggedPdfCheckBox;

        private System.Windows.Forms.TextBox
            TitleBox, PaperSizeWidthTextBox, PaperSizeHeightTextBox, MarginTopTextBox, MarginBottomTextBox, MarginLeftTextBox,
            MarginRightTextBox, BorderWidthTextBox, BorderSpacingTextBox, PageNumBeforeTextBox, PageNumMidTextBox,
            PageNumAfterTextBox, PageNumDistanceTextBox, OwnerPwdTextBox, UserPwdTextBox;

        private System.Windows.Forms.ComboBox PaperSizeUnitComboBox, MarginUnitComboBox, BorderTypeComboBox,
            BorderSpacingUnitComboBox, PageNumDistanceUnitComboBox, PageNumHorizAlignComboBox, PageNumVertAlignComboBox,
            PictQualityComboBox, CompLevelComboBox;

        private System.Windows.Forms.RadioButton OrientPortraitRadioButton, OrientLandscapeRadioButton;

        private System.Windows.Forms.Label PageNumPreviewLabel;

        private System.Windows.Forms.Button ColorPreviewButton, AddButton;
        private System.Windows.Forms.ColorDialog ColorDialog;

        private FileEmbedStructure FileEmbeddings;

        //private delegate void CheckBoxDisablerDelegate(object sender, System.EventArgs e);
        //private delegate void OneTimeEventDelegate(object sender, System.EventArgs e);

        public OptionsState OptState;

        FormBuilder CompBuilder;

        public const int WIDTH = 400;
        public int WIDTH_EXT = WIDTH;
        public const int HEIGHT = 500;
        const int TAB_HEIGHT = 50;
        const int BUTTON_HEIGHT = 20;
        const int BUTTON_WIDTH = 90;
        const int UNIT_BOX_WIDTH = 40;
        const int BUTTON_WIDTH_LONG = 120;
        const int SPACING = 5;
        const int TAB_TOP_OFFSET = 10;
        const int CHECKBOX_WIDTH = 12;

        /**************************************************
            OptionsForm:
            Initializes the options form dialog to reflect
            the user's current settings passed to and from
            the main dialog.
         **************************************************/
        public OptionsForm(OptionsState MainOptState) {
            this.OptState = MainOptState;
            InitializeComponent();
        }

        /**************************************************
            InitializeComponent:
            Called upon creation to generate all tabs and
            tab controls for the options menu dialog, along
            with the permanent buttons at the bottom. Invokes
            initialization of the tab contents from their
            respective methods.
         **************************************************/
        private void InitializeComponent() {

            int TabPos = 0;

            /* Locale Test
            System.Globalization.CultureInfo.CurrentCulture = new System.Globalization.CultureInfo("en-UK", false);
            */

            WIDTH_EXT = WIDTH + SystemInformation.VerticalScrollBarWidth;

            ColorDialog = new System.Windows.Forms.ColorDialog();

            this.Text = "Options";

            this.components = new System.ComponentModel.Container();

            TabControls = new System.Windows.Forms.TabControl();
            TabControls.Location = new System.Drawing.Point(0, 0);
            TabControls.Size = new System.Drawing.Size(WIDTH_EXT, HEIGHT - BUTTON_HEIGHT - 2 * SPACING);
            TabControls.SelectedIndex = 0;
            TabControls.TabIndex = TabPos++;

            FormatTab = new System.Windows.Forms.TabPage();
            FormatTab.Text = "Format";
            FormatTab.Size = new System.Drawing.Size(WIDTH_EXT, 214);
            FormatTab.TabIndex = TabPos++;
            FormatTab.AutoScroll = true;
            this.TabControls.Controls.Add(this.FormatTab);

            // 01192021: splitting tabs to avoid scrolling
            PageTab = new System.Windows.Forms.TabPage(); // 12182020 added page tab
            PageTab.Text = "Page";
            PageTab.Size = new System.Drawing.Size(WIDTH_EXT, 214);
            PageTab.TabIndex = TabPos++;
            PageTab.AutoScroll = true;
            this.TabControls.Controls.Add(this.PageTab);

            SecurityTab = new System.Windows.Forms.TabPage();
            SecurityTab.Text = "Security";
            SecurityTab.Size = new System.Drawing.Size(256, 214);
            SecurityTab.TabIndex = TabPos++;
            this.TabControls.Controls.Add(this.SecurityTab);

            QualityTab = new System.Windows.Forms.TabPage();
            QualityTab.Text = "Quality";
            QualityTab.Size = new System.Drawing.Size(256, 214);
            QualityTab.TabIndex = TabPos++;
            this.TabControls.Controls.Add(this.QualityTab);

            CompatTab = new System.Windows.Forms.TabPage();
            CompatTab.Text = "Compatability";
            CompatTab.Size = new System.Drawing.Size(256, 214);
            CompatTab.TabIndex = TabPos++;
            this.TabControls.Controls.Add(this.CompatTab);

            PrintingTab = new System.Windows.Forms.TabPage();
            PrintingTab.Text = "Printing";
            PrintingTab.Size = new System.Drawing.Size(256, 214);
            PrintingTab.TabIndex = TabPos++;
            this.TabControls.Controls.Add(this.PrintingTab);

            OtherTab = new System.Windows.Forms.TabPage();
            OtherTab.Text = "Other";
            OtherTab.Size = new System.Drawing.Size(256, 214);
            OtherTab.TabIndex = TabPos++;
            this.TabControls.Controls.Add(this.OtherTab);

            InitializeFormatTab();
            InitializePageTab();
            InitializeSecurityTab();
            InitializeQualityTab();
            InitializeCompatabilityTab();
            InitializePrintTab();
            InitializeOtherTab();

            //
            // ApplyButton
            //
            int ButtonPos = WIDTH;
            ButtonPos -= BUTTON_WIDTH + SPACING;
            this.ApplyButton = new System.Windows.Forms.Button();
            this.ApplyButton.Location = new System.Drawing.Point(ButtonPos, HEIGHT - (BUTTON_HEIGHT + SPACING));
            this.ApplyButton.Size = new System.Drawing.Size(BUTTON_WIDTH, BUTTON_HEIGHT);
            this.ApplyButton.Name = "Apply";
            this.ApplyButton.Text = "Apply";
            this.ApplyButton.TabIndex = TabPos++;
            this.ApplyButton.Click += new System.EventHandler(this.ApplyButton_Click);

            //
            // CancelBtn
            //
            ButtonPos -= BUTTON_WIDTH + SPACING;
            this.CancelBtn = new System.Windows.Forms.Button();
            this.CancelBtn.Location = new System.Drawing.Point(ButtonPos, HEIGHT - (BUTTON_HEIGHT + SPACING));
            this.CancelBtn.Size = new System.Drawing.Size(BUTTON_WIDTH, BUTTON_HEIGHT);
            this.CancelBtn.Name = "Cancel";
            this.CancelBtn.Text = "Cancel";
            this.CancelBtn.TabIndex = TabPos++;
            this.CancelBtn.Click += new System.EventHandler(this.CancelBtn_Click);

            this.Controls.Add(this.TabControls);
            this.Controls.Add(this.ApplyButton);
            this.Controls.Add(this.CancelBtn);

            Rectangle screen = this.RectangleToScreen(this.ClientRectangle);
            System.Drawing.Size BorderSize = System.Windows.Forms.SystemInformation.BorderSize;
            int TitleHeight = screen.Top - this.Top;
            // this.Size = new System.Drawing.Size(WIDTH + 2 * BorderSize.Width, HEIGHT + 2 * BorderSize.Height + TitleHeight);
            this.ClientSize = new System.Drawing.Size(WIDTH_EXT, HEIGHT);
        }

        /**************************************************
            InitializeFormatTab:
            Creates all form elements on the format tab, sets
            up event handling for them, and initializes them
            to current user settings.
         **************************************************/
         private void InitializeFormatTab() {
           FormBuilder Builder = CreateStandardFormBuilder();
           Builder.SetParent(FormatTab);
           CreateLabel(Builder, "PDF Title", -1);
           TitleBox = CreateTextBox(Builder, OptState.title, BUTTON_WIDTH_LONG, OptState.title);

           /////////////
           // MARGINS //
           /////////////
           // start of margin Builder
           FormBuilder MarginBuilder = Builder.StartGroupBox("MARGINS");
           MarginCheckBox = CreateCheckBox(MarginBuilder, "MarginCheckBox", CHECKBOX_WIDTH, OptState.setMargins);
           CreateLabel(MarginBuilder, "Use custom margins", -1);
           MarginBuilder.NewLine();
           CreateLabel(MarginBuilder, "Margin Units", BUTTON_WIDTH);
           MarginUnitComboBox = CreateUnitComboBox(MarginBuilder, "MarginUnitComboBox", UNIT_BOX_WIDTH, OptState.marginUnit);
           MarginBuilder.NewLine();
           CreateLabel(MarginBuilder, "Margin Top", BUTTON_WIDTH);
           MarginTopTextBox = CreateNumberBox(MarginBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.marginTop, OptState.marginUnit));
           MarginBuilder.NewLine();
           CreateLabel(MarginBuilder, "Margin Bottom", BUTTON_WIDTH);
           MarginBottomTextBox = CreateNumberBox(MarginBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.marginBottom, OptState.marginUnit));
           MarginBuilder.NewLine();
           CreateLabel(MarginBuilder, "Margin Left", BUTTON_WIDTH);
           MarginLeftTextBox = CreateNumberBox(MarginBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.marginLeft, OptState.marginUnit));
           MarginBuilder.NewLine();
           CreateLabel(MarginBuilder, "Margin Right", BUTTON_WIDTH);
           MarginRightTextBox = CreateNumberBox(MarginBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.marginRight, OptState.marginUnit));
           // make margin checkbox control enabling/disabling margin fields
           ActivateFieldsCheckBox(
               MarginCheckBox, MarginTopTextBox, MarginBottomTextBox, MarginLeftTextBox, MarginRightTextBox,
               MarginUnitComboBox);
           // end of margin Builder
           Builder.EndGroupBox(MarginBuilder);
           ////////////
           // BORDER //
           ////////////

           FormBuilder BorderBuilder = Builder.StartGroupBox("BORDER");
           BorderCheckBox = CreateCheckBox(BorderBuilder, "BorderCheckBox", CHECKBOX_WIDTH, OptState.hasBorder);
           CreateLabel(BorderBuilder, "Use custom border", -1);
           BorderBuilder.NewLine();
           CreateLabel(BorderBuilder, "Border Type", BUTTON_WIDTH);
           BorderTypeComboBox = new System.Windows.Forms.ComboBox();
           BorderTypeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
           BorderBuilder.Add(BorderTypeComboBox, "BorderTypeListBox", BUTTON_WIDTH_LONG);
           BorderTypeComboBox.BeginUpdate();
           BorderTypeComboBox.Items.Add("Single");
           BorderTypeComboBox.Items.Add("Double");
           BorderTypeComboBox.Items.Add("Triple");
           BorderTypeComboBox.Items.Add("Shadow");
           BorderTypeComboBox.Items.Add("Thick Thin");
           BorderTypeComboBox.Items.Add("Thick Thin Thick");
           BorderTypeComboBox.Items.Add("Thin Thick");
           BorderTypeComboBox.Items.Add("Thin Thick Thin");
           BorderTypeComboBox.Items.Add("None / Last");
           BorderTypeComboBox.EndUpdate();
           BorderTypeComboBox.SelectedIndex = OptState.borderType;
           BorderBuilder.NewLine();
           CreateLabel(BorderBuilder, "Border Width", BUTTON_WIDTH);
           BorderWidthTextBox = CreateNumberBox(BorderBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.borderWidth, OptionsState.UNIT_PT));
           CreateLabel(BorderBuilder, "points", -1);
           BorderBuilder.NewLine();
           CreateLabel(BorderBuilder, "Border Spacing", BUTTON_WIDTH);
           BorderSpacingTextBox = CreateNumberBox(BorderBuilder, "", BUTTON_WIDTH, OptState.borderSpace);
           BorderSpacingUnitComboBox = CreateUnitComboBox(BorderBuilder, "BorderSpacingUnitComboBox", UNIT_BOX_WIDTH, OptState.borderSpaceUnit);
           BorderSpacingTextBox.Text = String.Format("{0:0.####}", ConvertFromTwips(OptState.borderSpace, OptState.borderSpaceUnit));
           BorderBuilder.NewLine();
           CreateLabel(BorderBuilder, "Border Color", BUTTON_WIDTH);
           ColorPreviewButton = new System.Windows.Forms.Button();
           ColorPreviewButton.FlatStyle = FlatStyle.Flat;
           ColorPreviewButton.FlatAppearance.BorderSize = 0;
           ColorPreviewButton.BackColor = OptState.borderColor;
           ColorPreviewButton.ForeColor = GetBWColor(OptState.borderColor);
           ColorPreviewButton.Text = "Select";
           BorderBuilder.Add(ColorPreviewButton, "", BUTTON_WIDTH);
           ColorPreviewButton.Click += new System.EventHandler(ColorPicker);
           // make the border checkbox control enabling/disabling the border fields
           ActivateFieldsCheckBox(
               BorderCheckBox, BorderTypeComboBox, BorderWidthTextBox, BorderSpacingTextBox,
               BorderSpacingUnitComboBox, ColorPreviewButton
               );
           Builder.EndGroupBox(BorderBuilder);

         }

    // 01192021: added tab to prevent scrolling
    /**************************************************
        InitializePageTab:
        Creates all form elements on the page tab, sets
        up event handling for them, and initializes them
        to current user settings.
     **************************************************/
        private void InitializePageTab() {
          FormBuilder Builder = CreateStandardFormBuilder();
          Builder.SetParent(PageTab);
          Builder.NewLines(-1);
          ////////////////
          // Paper Size //
          ////////////////
          FormBuilder PaperBuilder = Builder.StartGroupBox("PAPER");
          PaperSizeCustomCheckBox = CreateCheckBox(PaperBuilder, "PaperSizeCustomCheckBox", CHECKBOX_WIDTH, OptState.paperSizeCustom);
          CreateLabel(PaperBuilder, "Use a custom paper size", -1);
          PaperBuilder.NewLine();
          CreateLabel(PaperBuilder, "Paper Size Units", BUTTON_WIDTH);
          PaperSizeUnitComboBox = CreateUnitComboBox(PaperBuilder, "PaperSizeUnitComboBox", UNIT_BOX_WIDTH, OptState.paperSizeUnit);
          PaperBuilder.NewLine();
          CreateLabel(PaperBuilder, "Paper Width", BUTTON_WIDTH);
          PaperSizeWidthTextBox = CreateNumberBox(PaperBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.paperSizeWidth, OptState.paperSizeUnit));
          PaperBuilder.NewLine();
          CreateLabel(PaperBuilder, "Paper Height", BUTTON_WIDTH);
          PaperSizeHeightTextBox = CreateNumberBox(PaperBuilder, "", BUTTON_WIDTH, ConvertFromTwips(OptState.paperSizeHeight, OptState.paperSizeUnit));
          // make paper size checkbox control enabling/disabling paper size fields
          ActivateFieldsCheckBox(
              PaperSizeCustomCheckBox, PaperSizeUnitComboBox, PaperSizeWidthTextBox, PaperSizeHeightTextBox
              );
          PaperBuilder.NewLine();
          // Orientation

          CreateLabel(PaperBuilder, "Orientation", BUTTON_WIDTH);
          OrientLandscapeRadioButton = new System.Windows.Forms.RadioButton();
          PaperBuilder.Add(OrientLandscapeRadioButton, "olrb", CHECKBOX_WIDTH);
          OrientLandscapeRadioButton.Checked = !OptState.paperOrientIsPortrait;
          CreateLabel(PaperBuilder, "Landscape", -1);
          OrientPortraitRadioButton = new System.Windows.Forms.RadioButton();
          PaperBuilder.Add(OrientPortraitRadioButton, "oprb", CHECKBOX_WIDTH);
          OrientPortraitRadioButton.Checked = OptState.paperOrientIsPortrait;
          CreateLabel(PaperBuilder, "Portrait", -1);
          // group box end
          Builder.EndGroupBox(PaperBuilder);

          ////////////////////
          // PAGE NUMBERING //
          ////////////////////

          FormBuilder PageNumBuilder = Builder.StartGroupBox("PAGE NUMBERING");

          PageNumCheckBox = CreateCheckBox(PageNumBuilder, "PageNumCheckBox", CHECKBOX_WIDTH, OptState.printPageNumbers);
          CreateLabel(PageNumBuilder, "Show page numbers", -1);
          PageNumBuilder.NewLine();
          CreateLabel(PageNumBuilder, "Format", BUTTON_WIDTH);

          PageNumBeforeTextBox = CreateTextBox(PageNumBuilder, "", 40, OptState.beforeText);
          PageNumBeforeTextBox.TextChanged += new System.EventHandler(PageNumUpdatePreview);
          PageNumMidTextBox = CreateTextBox(PageNumBuilder, "", 40, OptState.midText);
          PageNumMidTextBox.TextChanged += new System.EventHandler(PageNumUpdatePreview);
          PageNumAfterTextBox = CreateTextBox(PageNumBuilder, "", 40, OptState.afterText);
          PageNumAfterTextBox.TextChanged += new System.EventHandler(PageNumUpdatePreview);
          PageNumBuilder.NewLine();
          CreateLabel(PageNumBuilder, "Preview", BUTTON_WIDTH);
          PageNumPreviewLabel = CreateLabel(PageNumBuilder, "", 40 * 3 + PageNumBuilder.GetHorizontalSpacing() * 2);
          PageNumPreviewLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
          PageNumBuilder.NewLine();
          CreateLabel(PageNumBuilder, "Edge spacing", BUTTON_WIDTH);
          PageNumDistanceTextBox = CreateNumberBox(PageNumBuilder, "", BUTTON_WIDTH, OptState.distanceFromEdge);
          PageNumDistanceUnitComboBox = CreateUnitComboBox(PageNumBuilder, "PageNumDistanceUnitComboBox", UNIT_BOX_WIDTH, OptState.distanceFromEdgeUnit);
          PageNumDistanceTextBox.Text = String.Format("{0:0.####}", ConvertFromTwips(OptState.distanceFromEdge, OptState.distanceFromEdgeUnit));
          PageNumBuilder.NewLine();
          CreateLabel(PageNumBuilder, "Alignment", BUTTON_WIDTH);
          // +-----------+-------+--------------+
          // | alignment | value | checkbox idx |
          // +-----------+-------+--------------+
          // | top       | 0x1   | 0            |
          // | bottom    | 0x2   | 1            |
          // +-----------+-------+--------------+
          PageNumVertAlignComboBox = CreateComboBox(PageNumBuilder, "", 60, OptState.verticalAlignment - 1, "top", "bottom");
          // +-----------+-------+--------------+
          // | alignment | value | checkbox idx |
          // +-----------+-------+--------------+
          // | left      | 0x0   | 0            | conversion function: idx = alignment / 4
          // | center    | 0x4   | 1            |
          // | right     | 0x8   | 2            |
          // +-----------+-------+--------------+
          PageNumHorizAlignComboBox = CreateComboBox(PageNumBuilder, "", 60, OptState.horizontalAlignment / 4, "left", "center", "right");
          // create initial preview
          PageNumUpdatePreview(null, null);
          ActivateFieldsCheckBox(
              PageNumCheckBox, PageNumBeforeTextBox, PageNumMidTextBox, PageNumAfterTextBox,
              PageNumDistanceTextBox, PageNumDistanceUnitComboBox, PageNumHorizAlignComboBox,
              PageNumVertAlignComboBox, PageNumPreviewLabel
              );

          Builder.EndGroupBox(PageNumBuilder);
        }

        /**************************************************
            InitializeSecurityTab:
            Creates all form elements on the security tab, sets
            up event handling for them, and initializes them
            to current user settings.
         **************************************************/
        private void InitializeSecurityTab() {

            FormBuilder Builder = CreateStandardFormBuilder();
            Builder.SetParent(SecurityTab);

            EncryptCheckBox = CreateCheckBoxLine(Builder, "Encrypt with AES128", CHECKBOX_WIDTH, OptState.usesEncryptionAES128);

            Builder.NewLines(-1);

            FormBuilder PwdBuilder = Builder.StartGroupBox("PASSWORDS");

            OwnerPwdCheckBox = CreateCheckBoxLine(PwdBuilder, "Owner password", CHECKBOX_WIDTH, OptState.hasOwnerPassword);
            OwnerPwdTextBox = CreatePasswordField(PwdBuilder, "", BUTTON_WIDTH, OptState.ownerPassword);
            ActivateFieldsMaker OwnerPwdActivateFieldsObj = new ActivateFieldsMaker(OwnerPwdCheckBox, OwnerPwdTextBox);
            OwnerPwdActivateFieldsObj.ActivateFields(null, null);
            OwnerPwdCheckBox.CheckedChanged += new System.EventHandler(OwnerPwdActivateFieldsObj.ActivateFields);

            PwdBuilder.NewLine();

            UserPwdCheckBox = CreateCheckBoxLine(PwdBuilder, "User password", CHECKBOX_WIDTH, OptState.hasUserPassword);
            UserPwdTextBox = CreatePasswordField(PwdBuilder, "", BUTTON_WIDTH, OptState.userPassword);
            ActivateFieldsMaker UserPwdActivateFieldsObj = new ActivateFieldsMaker(UserPwdCheckBox, UserPwdTextBox);
            UserPwdActivateFieldsObj.ActivateFields(null, null);
            UserPwdCheckBox.CheckedChanged += new System.EventHandler(UserPwdActivateFieldsObj.ActivateFields);

            // CheckBoxDisablerDelegate OwnerDisableUserPwdDelegate = CheckBoxDisabler(OwnerPwdCheckBox, UserPwdCheckBox);
            // OwnerDisableUserPwdDelegate(null, null);
            // OwnerPwdCheckBox.CheckedChanged += new System.EventHandler(OwnerDisableUserPwdDelegate);

            //PwdBuilder.NewLine();

            Builder.EndGroupBox(PwdBuilder);

            FormBuilder PermBuilder = Builder.StartGroupBox("PERMISSIONS");

            PwdUserCanPrintCheckBox  = CreateCheckBoxLine(PermBuilder, "User can print",  CHECKBOX_WIDTH, OptState.permPrint);
            PwdUserCanCopyCheckBox   = CreateCheckBoxLine(PermBuilder, "User can copy",   CHECKBOX_WIDTH, OptState.permCopy);
            PwdUserCanModifyCheckBox = CreateLabeledCheckBox(PermBuilder, "User can modify", CHECKBOX_WIDTH, OptState.permModify);

            Builder.EndGroupBox(PermBuilder);

        }

        /**************************************************
            InitializeQualityTab:
            Creates all form elements on the quality tab, sets
            up event handling for them, and initializes them
            to current user settings.
         **************************************************/
        private void InitializeQualityTab() {
            FormBuilder Builder = CreateStandardFormBuilder();
            Builder.SetParent(QualityTab);

            CompressTextCheckBox = CreateLabeledCheckBox(Builder, "Compress text", CHECKBOX_WIDTH, OptState.compressText);

            //Builder.NewLines(-1);

            FormBuilder ImgBuilder = Builder.StartGroupBox("IMAGES");

            UseOrigJpegsCheckBox = CreateCheckBoxLine(ImgBuilder, "Use original JPEGs",  CHECKBOX_WIDTH, OptState.useOrigJpg);
            EmfAsBmpCheckBox     = CreateCheckBoxLine(ImgBuilder, "Convert EMFs to BMPs", CHECKBOX_WIDTH, OptState.emfAsBmp);

            CreateLabel(ImgBuilder, "Picture quality", BUTTON_WIDTH);
            PictQualityComboBox = CreateComboBox(ImgBuilder, "PictureQualityComboBox", BUTTON_WIDTH, OptState.pictQuality-1, "lowest", "low", "average", "high", "highest");

            Builder.EndGroupBox(ImgBuilder);
        }

        /**************************************************
            InitializeCompatabilityTab:
            Creates all form elements on the compatability
            tab, sets up event handling for them, and
            initializes them to current user settings.
         **************************************************/
        private void InitializeCompatabilityTab() {

            FormBuilder Builder = CreateStandardFormBuilder();
            Builder.SetParent(CompatTab);
            CompatTab.AutoScroll = true;

            Builder.NewLines(-1);

            FormBuilder MiscBuilder = Builder.StartGroupBox("MISC");

            EmbedFontsCheckBox = CreateCheckBoxLine(MiscBuilder, "Embed fonts", CHECKBOX_WIDTH, OptState.embedFonts);
            LegSecPropCheckBox = CreateLabeledCheckBox(MiscBuilder, "Use legacy section properties", CHECKBOX_WIDTH, OptState.legacySectionProperties);

            Builder.EndGroupBox(MiscBuilder);

            CompBuilder = Builder.StartGroupBox("COMPLIANCE");

            TaggedPdfCheckBox = CreateCheckBoxLine(CompBuilder, "Tagged pdf", CHECKBOX_WIDTH, OptState.taggedPdf);

            CreateLabel(CompBuilder, "Compliance level", BUTTON_WIDTH_LONG);
            CompLevelComboBox = CreateComboBox(CompBuilder, "compliance", BUTTON_WIDTH, OptState.complianceLevel, "None", "Pdf A1b", "Pdf A", "Pdf A2b","Pdf UA", "Pdf A3");

            //CompBuilder.NewLine();

            FileEmbeddings = new FileEmbedStructure(this, CompBuilder, CompBuilder.UsableWidth());

            AddButton = FileEmbedElement.CreateFileEmbedHeader(this, CompBuilder, CompBuilder.UsableWidth());
            AddButton.Click += new System.EventHandler(AddFile);

            for (int i = 0; i < OptState.embedFiles.Count; i += 2) {
                AddFile(null, null);
                FileEmbedElement Elem = FileEmbeddings.GetHead();
                Elem.SetPath(OptState.embedFiles[i] as String);
                Elem.SetDesc(OptState.embedFiles[i + 1] as String);
            }

            ListActivator(null, null);
            CompLevelComboBox.SelectedIndexChanged += new System.EventHandler(ListActivator);

            Builder.EndGroupBox(CompBuilder);

        }

        /**************************************************
            ListActivator:
            If the user selects compliance level PDF-A3 on
            the compatability tab, the list of embedded files
            should be enabled, and disabled in the opposite case.
            This function handles that toggling by calling on
            the file embedding object to toggle its fields.
         **************************************************/
        void ListActivator(object sender, System.EventArgs e) {
            if (CompLevelComboBox.SelectedIndex == OptionsState.CMPL_PDFA3) {
                FileEmbeddings.ActivateAll();
                AddButton.Enabled = true;
            } else {
                FileEmbeddings.DeactivateAll();
                AddButton.Enabled = false;
            }
        }

        /**************************************************
            AddFile:
            For PDF-A3 compliance on the compatability tab,
            this function adds a new file embedding to the
            list of embeddings.
         **************************************************/
        void AddFile(object sender, System.EventArgs e) {
            FileEmbeddings.Add();
            // extend group box to contain new elements
            System.Windows.Forms.GroupBox CompGroupBox = CompBuilder.GetParent() as System.Windows.Forms.GroupBox;
            CompGroupBox.Size = new System.Drawing.Size(
                CompGroupBox.Size.Width,
                CompGroupBox.Size.Height + CompBuilder.LineHeightPlusSpacing() * 2
                );
        }

        /**************************************************
            InitializePrintTab:
            Creates all form elements on the print tab, sets
            up event handling for them, and initializes them
            to current user settings.
         **************************************************/
        private void InitializePrintTab() {

            FormBuilder Builder = CreateStandardFormBuilder();
            Builder.SetParent(PrintingTab);
            PrintingTab.AutoScroll = true;

            NoScalingCheckBox = CreateLabeledCheckBox(Builder, "No scaling", CHECKBOX_WIDTH, OptState.noScaling);

            FormBuilder DuplexBuilder = Builder.StartGroupBox("DUPLEX");

            DuplexShortCheckBox = CreateCheckBoxLine(DuplexBuilder, "Duplex on short side", CHECKBOX_WIDTH, OptState.duplexShort);
            DuplexLongCheckBox  = CreateLabeledCheckBox(DuplexBuilder, "Duplex on long side",  CHECKBOX_WIDTH, OptState.duplexLong);

            Builder.EndGroupBox(DuplexBuilder);

            /*
            // checkbox
            public bool noScaling = false, duplexShort = false, duplexLong = false;

            */
        }

        /**************************************************
            InitializeOtherTab:
            Creates all form elements on the "other" tab, sets
            up event handling for them, and initializes them
            to current user settings.
         **************************************************/
        private void InitializeOtherTab() {

            FormBuilder Builder = CreateStandardFormBuilder();
            Builder.SetParent(OtherTab);
            OtherTab.AutoScroll = true;

            InWebServerCheckBox     = CreateCheckBoxLine(Builder, "In web server",    CHECKBOX_WIDTH, OptState.inWebServer);
            DoCachingCheckBox       = CreateCheckBoxLine(Builder, "Do caching",       CHECKBOX_WIDTH, OptState.doCaching);
            IsolateUnicodeCheckBox  = CreateCheckBoxLine(Builder, "Isolate Unicode",  CHECKBOX_WIDTH, OptState.isolateUnicode);
            HideTrackingCheckBox    = CreateCheckBoxLine(Builder, "Hide tracking",    CHECKBOX_WIDTH, OptState.hideTracking);
            NoTOCUpdateCheckBox     = CreateCheckBoxLine(Builder, "No TOC update",    CHECKBOX_WIDTH, OptState.noTocUpdate);
            ClearBackgroundCheckBox = CreateCheckBoxLine(Builder, "Clear background", CHECKBOX_WIDTH, OptState.clearBackground);
            HideCommentsCheckBox    = CreateCheckBoxLine(Builder, "Hide comments", CHECKBOX_WIDTH, OptState.hideComments);
            // 01192021: added from format tab because it doesnt fit on format or page tabs without scrolling
            OmitLastEmptyPageCheckBox  = CreateLabeledCheckBox(Builder, "Omit last page if empty", CHECKBOX_WIDTH, OptState.omitLastEmptyPage);      Builder.NewLine();
            ExpandWidthCheckBox        = CreateLabeledCheckBox(Builder, "Expand width", CHECKBOX_WIDTH, OptState.expandWidth);                       Builder.NewLine();
            ShrinkImagesToFitCheckBox  = CreateLabeledCheckBox(Builder, "Shrink images to fit on page", CHECKBOX_WIDTH, OptState.shrinkImagesToFit); Builder.NewLine();
            ExactTextPlacementCheckBox = CreateLabeledCheckBox(Builder, "Exact text placement", CHECKBOX_WIDTH, OptState.exactTextPlacement);        Builder.NewLine();
            ConvertComboBoxesCheckBox  = CreateLabeledCheckBox(Builder, "Convert combo boxes", CHECKBOX_WIDTH, OptState.convertComboBox);
        }

        // FORM CONTROL CREATION HELPER FUNCTIONS

        /**************************************************
            CreateStandardFormBuilder:
            Creates a FormBuilder object with the standard look
            and feel (v/h spacing, margins, tab level)
         **************************************************/
        private FormBuilder CreateStandardFormBuilder() {
            return new FormBuilder(OptionsForm.WIDTH, OptionsForm.HEIGHT, 5, 5, 15, 25, 5, 5, 20, 20);
        }

        /**************************************************
            CreateLabel:
            Creates a label form control at the current
            Builder position, horizontally advances the Builder
            Builder: Builder to use in positioning the form element
            title: the text in the label
            width: the width of the element, -1 for width of title string in the form's font.
         **************************************************/
        public System.Windows.Forms.Label CreateLabel(FormBuilder Builder, String title, int width) {
            String LabelTitle = title;
            System.Windows.Forms.Label Label = new System.Windows.Forms.Label();
            Builder.Add(Label, LabelTitle, width);
            Label.Text = LabelTitle;
            return Label;
        }

        /**************************************************
            CreateNumberBox:
            Creates a textbox form control at the current
            Builder position, sets the default value, horizontally
            advances the Builder, sets up the textbox to validate
            numerical input and format number values correctly.
            Builder: Builder to use in positioning the form element
            title: the internal title of the element
            width: the width of the element
            InitValue: the initial value in the textbox's field, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.TextBox CreateNumberBox(FormBuilder Builder, String title, int width, double InitValue) {
            System.Windows.Forms.TextBox TextBox = new System.Windows.Forms.TextBox();
            Builder.Add(TextBox, title, width);
            TextBox.TextChanged += new System.EventHandler(TextValidator);
            TextBox.Text = String.Format("{0:0.####}", InitValue);
            return TextBox;
        }

        /**************************************************
            CreateTextBox:
            Creates a textbox form control at the current
            Builder position, sets the default value, horizontally
            advances the Builder.
            Builder: Builder to use in positioning the form element
            title: the internal title of the element
            width: the width of the element
            InitValue: the initial value in the textbox's field, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.TextBox CreateTextBox(FormBuilder Builder, String title, int width, String InitValue) {
            System.Windows.Forms.TextBox TextBox = new System.Windows.Forms.TextBox();
            Builder.Add(TextBox, title, width);
            TextBox.Text = InitValue;
            return TextBox;
        }

        /**************************************************
            CreateCheckBox:
            Creates a checkbox form control at the current
            Builder position, sets the default value, horizontally
            advances the Builder.
            Builder: Builder to use in positioning the form element
            title: the internal title of the element
            width: the width of the element
            InitValue: the initial boolean value of the checkbox, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.CheckBox CreateCheckBox(FormBuilder Builder, String title, int width, bool InitValue) {
            System.Windows.Forms.CheckBox CheckBox = new System.Windows.Forms.CheckBox();
            Builder.Add(CheckBox, title, width);
            CheckBox.Checked = InitValue;
            return CheckBox;
        }

        /**************************************************
            CreateButton:
            Creates a button form control at the current
            Builder position, horizontally advances the Builder.
            Builder: Builder to use in positioning the form element
            title: the text on the element
            width: the width of the element
         **************************************************/
        public System.Windows.Forms.Button CreateButton(FormBuilder Builder, String title, int width) {
            System.Windows.Forms.Button Button = new System.Windows.Forms.Button();
            Builder.Add(Button, title, width);
            Button.Text = title;
            return Button;
        }

        /**************************************************
            CreateLabeledCheckBox:
            Creates checkbox and label form controls at the current
            Builder position, sets the default value of the checkbox,
            horizontally advances the Builder.
            Builder: Builder to use in positioning the form element
            label: the label text to the left of the checkbox
            width: the width of the checkbox, the label fits its text width
            InitValue: the initial boolean value of the checkbox, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.CheckBox CreateLabeledCheckBox(FormBuilder Builder, String label, int width, bool InitValue) {
            System.Windows.Forms.CheckBox CheckBox = new System.Windows.Forms.CheckBox();
            Builder.Add(CheckBox, "", width);
            CheckBox.Checked = InitValue;
            CreateLabel(Builder, label, -1);
            return CheckBox;
        }

        /**************************************************
            CreateCheckBoxLine:
            Same as CreateLabeledCheckBox but performs a "carriage return"
            on the Builder, returning to the horizontal position of a new line
            and advancing the Builder vertically.
            Builder: Builder to use in positioning the form element
            label: the label text to the left of the checkbox
            width: the width of the checkbox, the label fits its text width
            InitValue: the initial boolean value of the checkbox, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.CheckBox CreateCheckBoxLine(FormBuilder Builder, String label, int width, bool InitValue) {
            System.Windows.Forms.CheckBox CheckBox = new System.Windows.Forms.CheckBox();
            Builder.Add(CheckBox, "", width);
            CheckBox.Checked = InitValue;
            CreateLabel(Builder, label, -1);
            Builder.NewLine();
            return CheckBox;
        }

        /**************************************************
            CreatePasswordField:
            Creates a textbox form control at the current Builder
            position, horizontally advancing the Builder. Also
            configures the textbox to hide the field's contents
            and creates a button next to the field for temporarily
            revealing the field's contents.
            Builder: Builder to use in positioning the form element
            label: the internal title of the textbox
            width: the width of the textbox
            InitValue: the initial value in the textbox's field, usually from the OptionsState
                       passed in at creation time.
         **************************************************/
        public System.Windows.Forms.TextBox CreatePasswordField(FormBuilder Builder, String label, int width, String InitValue) {
            System.Windows.Forms.TextBox TextBox = CreateTextBox(Builder, label, width, InitValue);
            TextBox.PasswordChar = '*';
            System.Windows.Forms.Button ShowButton = CreateButton(Builder, "", 30);
            ToolTip ShowTip = new ToolTip();
            //ShowTip.AutomaticDelay = 5000;
            ShowTip.InitialDelay = 0;
            ShowTip.ShowAlways = true;
            ShowTip.SetToolTip(ShowButton, "Show");

            DrawEyeballMaker DrawEyeballObj = new DrawEyeballMaker(ShowButton, TextBox, ShowTip);
            WireUpPasswordFieldsMaker WireUpObj = new WireUpPasswordFieldsMaker(ShowButton, TextBox);
            return TextBox;
        }

        /**************************************************
            ColorPicker:
            Event handler for the color picker button, sets
            up the creation of a color selection dialog on
            click, and switches to the selected color upon
            successful color selection from that dialog.
        **************************************************/
        public void ColorPicker(object sender, System.EventArgs e) {
            System.Windows.Forms.Control control = sender as System.Windows.Forms.Control;
            if (ColorDialog.ShowDialog() == DialogResult.OK) {
                control.BackColor = ColorDialog.Color;
                control.ForeColor = GetBWColor(ColorDialog.Color);
            }
        }

        /**************************************************
            GetBWColor:
            Chooses black or white depending on which will
            contrast better with the given color.
            color: the color to contrast with.
         **************************************************/
        public Color GetBWColor(Color color) {
            if (color.R + color.G + color.B > 360) {
                return Color.Black;
            } else {
                return Color.White;
            }
        }

        /**************************************************
            CreateUnitComboBox:
            Creates a combobox form control at the current
            Builder position, horizontally advances the Builder, sets
            the options to "cm" and "in" units.
            Builder: Builder to use in positioning the form element
            title: the internal title of the control
            width: the width of the element.
            InitValue: the index of the initial list selection,
                       set to OptionsState.UNIT_NONE for default based on user locale.
         **************************************************/
        public System.Windows.Forms.ComboBox CreateUnitComboBox(FormBuilder Builder, String title, int width, int InitValue) {
            System.Windows.Forms.ComboBox UnitComboBox = new System.Windows.Forms.ComboBox();
            UnitComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            Builder.Add(UnitComboBox, title, width);
            UnitComboBox.BeginUpdate();
            UnitComboBox.Items.Add("in");
            UnitComboBox.Items.Add("cm");
            UnitComboBox.EndUpdate();
            // Check current locale for default units
            if (InitValue == OptionsState.UNIT_NONE) {
                UnitComboBox.SelectedIndex = LocaleUnits();
            } else {
                UnitComboBox.SelectedIndex = InitValue;
            }
            return UnitComboBox;
        }

        /**************************************************
            LocaleUnits:
            Determine measurement units in the current locale
            based on system info.
         **************************************************/
        public int LocaleUnits() {
            if (System.Globalization.CultureInfo.CurrentCulture.Name == "en-US") {
                return OptionsState.UNIT_IN;
            } else {
                return OptionsState.UNIT_CM;
            }
        }

        /**************************************************
            CreateComboBox:
            Creates a combobox form control at the current
            Builder position, horizontally advances the Builder.
            Builder: Builder to use in positioning the form element
            title: the internal title of the control
            width: the width of the element.
            InitValue: the index of the initial list selection.
            vals: the list of values to be selected from in the combobox.
         **************************************************/
        public System.Windows.Forms.ComboBox CreateComboBox(FormBuilder Builder, String title, int width, int InitValue, params String[] vals) {
            System.Windows.Forms.ComboBox ComboBox = new System.Windows.Forms.ComboBox();
            ComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            Builder.Add(ComboBox, title, width);
            ComboBox.BeginUpdate();
            for(int i = 0; i < vals.Length; i++) {
                ComboBox.Items.Add(vals[i]);
            }
            ComboBox.EndUpdate();
            ComboBox.SelectedIndex = InitValue;

            return ComboBox;
        }

        // EVENT HANDLERS

        /**************************************************
            TextValidator:
            Event handler that determines if the text in a
            number textbox is in fact a number. Sets the text
            to red if invalid number.
         **************************************************/
        void TextValidator(object sender, System.EventArgs e) {
            System.Windows.Forms.TextBox TextBox = sender as System.Windows.Forms.TextBox;
            try {
                if (double.Parse(TextBox.Text) < 0) {
                    TextBox.ForeColor = Color.Red;
                } else {
                    TextBox.ForeColor = Color.Black;
                }
            } catch {
                TextBox.ForeColor = Color.Red;
            }
        }

        /**************************************************
            PageNumUpdatePreview:
            Updates the text content of the page numbering
            format preview label to reflect the user's
            textual modifications to the page num pre mid
            and post fix labels.
         **************************************************/
        void PageNumUpdatePreview(object sender, System.EventArgs e) {
            PageNumPreviewLabel.Text =
                PageNumBeforeTextBox.Text + " 5 " +
                PageNumMidTextBox.Text + " 12 " +
                PageNumAfterTextBox.Text;
        }

        /**************************************************
            ActivateFieldsCheckBox:
            Set up checkbox toggle event handlers to enable
            or disable fields controlled by whether an option
            is set or unset. Initially sets enabled status of
            the components.
            CheckBox: the checkbox that controls the event
            controls: the controls enabled/disabled by the checkbox
         **************************************************/
        void ActivateFieldsCheckBox(System.Windows.Forms.CheckBox CheckBox, params System.Windows.Forms.Control[] controls) {
            ActivateFieldsMaker ActivateFieldsObj = new ActivateFieldsMaker(CheckBox, controls);
            // initial activation
            ActivateFieldsObj.ActivateFields(null, null);
            // activation on user toggle
            CheckBox.CheckedChanged += new System.EventHandler(ActivateFieldsObj.ActivateFields);
        }

        /**************************************************
            CancelBtn_Click:
            Event that closes the options dialog without
            applying the changes set in the options dialog.
            Used by the Cancel button.
         **************************************************/
        public void CancelBtn_Click(object sender, System.EventArgs e) {
            this.Close();
        }

        /**************************************************
            ApplyButton_Click:
            Event that first validates the contents of all the
            user's input. if successful, it then applies the
            changes and closes the options dialog.
            If the user has input something invalid into a number
            textbox or left it blank, the dialog will switch tabs
            to the first occurrence of such erroneous input and
            highlight it red until corrected or disabled.
         **************************************************/
        public void ApplyButton_Click(object sender, System.EventArgs e) {

            OptState.title = TitleBox.Text;

            // paper groupbox

            OptState.paperSizeCustom = PaperSizeCustomCheckBox.Checked;
            if (OptState.paperSizeCustom) {
                OptState.paperSizeUnit = PaperSizeUnitComboBox.SelectedIndex;
                double width = ValidateAndSet(PaperSizeWidthTextBox.Text, PaperSizeUnitComboBox.SelectedIndex, "Paper width", FormatTab);
                if(width == -1) {
                    HighlightSystem WidthHighlight = new HighlightSystem(PaperSizeWidthTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.paperSizeWidth = (int) width;
                }
                double height = ValidateAndSet(PaperSizeHeightTextBox.Text, PaperSizeUnitComboBox.SelectedIndex, "Paper height", FormatTab);
                if(height == -1) {
                    HighlightSystem HeightHighlight = new HighlightSystem(PaperSizeHeightTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.paperSizeHeight = (int) height;
                }
            }
            OptState.paperOrientIsPortrait = OrientPortraitRadioButton.Checked;

            // margins groupbox

            OptState.setMargins = MarginCheckBox.Checked;
            if(OptState.setMargins) {
                OptState.marginUnit = MarginUnitComboBox.SelectedIndex;
                double marginTop = ValidateAndSet(MarginTopTextBox.Text, MarginUnitComboBox.SelectedIndex, "Margin top", FormatTab);
                if (marginTop == -1) {
                    HighlightSystem MarginTopHighlight = new HighlightSystem(MarginTopTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.marginTop = (int) marginTop;
                }
                double marginBottom = ValidateAndSet(MarginBottomTextBox.Text, MarginUnitComboBox.SelectedIndex, "Margin bottom", FormatTab);
                if (marginBottom == -1) {
                    HighlightSystem MarginBottomHighlight = new HighlightSystem(MarginBottomTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.marginBottom = (int) marginBottom;
                }
                double marginLeft = ValidateAndSet(MarginLeftTextBox.Text, MarginUnitComboBox.SelectedIndex, "Margin left", FormatTab);
                if (marginLeft == -1) {
                    HighlightSystem MarginLeftHighlight = new HighlightSystem(MarginLeftTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.marginLeft = (int) marginLeft;
                }
                double marginRight = ValidateAndSet(MarginRightTextBox.Text, MarginUnitComboBox.SelectedIndex, "Margin right", FormatTab);
                if (marginRight == -1) {
                    HighlightSystem MarginRightHighlight = new HighlightSystem(MarginRightTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.marginRight = (int) marginRight;
                }
            }

            // border groupbox

            OptState.hasBorder = BorderCheckBox.Checked;
            if(OptState.hasBorder) {
                OptState.borderSpaceUnit = BorderSpacingUnitComboBox.SelectedIndex;
                OptState.borderType = BorderTypeComboBox.SelectedIndex;
                double borderWidth = ValidateAndSet(BorderWidthTextBox.Text, OptionsState.UNIT_PT, "Border width", FormatTab);
                if (borderWidth == -1) {
                    HighlightSystem BorderWidthHighlight = new HighlightSystem(BorderWidthTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.borderWidth = (int) borderWidth;
                }
                double borderSpace = ValidateAndSet(BorderSpacingTextBox.Text, BorderSpacingUnitComboBox.SelectedIndex, "Border spacing", FormatTab);
                if (borderSpace == -1) {
                    HighlightSystem BorderSpacingHighlight = new HighlightSystem(BorderSpacingTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.borderSpace = (int) borderSpace;
                }
                OptState.borderColor = ColorPreviewButton.BackColor;
            }

            // page numbering

            OptState.printPageNumbers = PageNumCheckBox.Checked;
            if(OptState.printPageNumbers) {
                OptState.distanceFromEdgeUnit = PageNumDistanceUnitComboBox.SelectedIndex;
                OptState.beforeText = PageNumBeforeTextBox.Text;
                OptState.midText    = PageNumMidTextBox.Text;
                OptState.afterText  = PageNumAfterTextBox.Text;
                double edgeSpacing  = ValidateAndSet(PageNumDistanceTextBox.Text, PageNumDistanceUnitComboBox.SelectedIndex, "Page number spacing from edge", FormatTab);
                if (edgeSpacing == -1) {
                    HighlightSystem PageNumDistanceHighlight = new HighlightSystem(PageNumDistanceTextBox);
                    return; // short circuit, user needs to fix something
                } else {
                    OptState.distanceFromEdge = (int)edgeSpacing;
                }

                // align vertical
                // +-----------+-------+--------------+
                // | alignment | value | checkbox idx |
                // +-----------+-------+--------------+
                // | top       | 0x1   | 0            | conversion function:
                // | bottom    | 0x2   | 1            | idx = alignment - 1
                // +-----------+-------+--------------+ alignment = idx + 1
                OptState.verticalAlignment = PageNumVertAlignComboBox.SelectedIndex + 1;

                // align horizontal
                // +-----------+-------+--------------+
                // | alignment | value | checkbox idx |
                // +-----------+-------+--------------+
                // | left      | 0x0   | 0            | conversion function:
                // | center    | 0x4   | 1            | idx = alignment / 4
                // | right     | 0x8   | 2            | alignment = idx * 4
                // +-----------+-------+--------------+
                OptState.horizontalAlignment = PageNumHorizAlignComboBox.SelectedIndex * 4;

            }

            // misc groupbox

            OptState.omitLastEmptyPage = OmitLastEmptyPageCheckBox.Checked;
            OptState.expandWidth = ExpandWidthCheckBox.Checked;
            OptState.shrinkImagesToFit = ShrinkImagesToFitCheckBox.Checked;
            OptState.exactTextPlacement = ExactTextPlacementCheckBox.Checked;
            OptState.convertComboBox = ConvertComboBoxesCheckBox.Checked;

            // security tab

            OptState.usesEncryptionAES128 = EncryptCheckBox.Checked;

            // passwords groupbox

            OptState.hasOwnerPassword = OwnerPwdCheckBox.Checked;
            if(OptState.hasOwnerPassword) {
                OptState.ownerPassword = OwnerPwdTextBox.Text;
                OptState.hasUserPassword = UserPwdCheckBox.Checked;
                if(OptState.hasUserPassword) {
                    OptState.userPassword = UserPwdTextBox.Text;
                    OptState.permPrint  = PwdUserCanPrintCheckBox.Checked;
                    OptState.permCopy   = PwdUserCanCopyCheckBox.Checked;
                    OptState.permModify = PwdUserCanModifyCheckBox.Checked;
                }
            }

            // quality tab

            OptState.compressText = CompressTextCheckBox.Checked;

            // images groupbox

            OptState.useOrigJpg = UseOrigJpegsCheckBox.Checked;
            OptState.emfAsBmp = EmfAsBmpCheckBox.Checked;
            OptState.pictQuality = PictQualityComboBox.SelectedIndex + 1;

            // compatability tab

            // misc groupbox

            OptState.embedFonts = EmbedFontsCheckBox.Checked;
            OptState.legacySectionProperties = LegSecPropCheckBox.Checked;

            // compliance groupbox

            OptState.embedFiles.Clear();

            OptState.complianceLevel = CompLevelComboBox.SelectedIndex;
            ArrayList StringList = FileEmbeddings.GetStringsForState();
            for(int i = 0; i < StringList.Count; i++) {
                OptState.embedFiles.Add(StringList[i]);
            }
            String EmbedFilesString = "";
            for(int i = 0; i < OptState.embedFiles.Count; i+=2) {
                EmbedFilesString += OptState.embedFiles[i] + ":" + OptState.embedFiles[i + 1] + ",";
            }

            // remove files, these are reloaded from the state upon reopening options dialog
            FileEmbeddings.Clear();

            // print tab

            OptState.noScaling = NoScalingCheckBox.Checked;

            // duplex groupbox

            OptState.duplexShort = DuplexShortCheckBox.Checked;
            OptState.duplexLong  = DuplexLongCheckBox.Checked;

            // other tab

            OptState.inWebServer     = InWebServerCheckBox.Checked;
            OptState.doCaching       = DoCachingCheckBox.Checked;
            OptState.isolateUnicode  = IsolateUnicodeCheckBox.Checked;
            OptState.hideTracking    = HideTrackingCheckBox.Checked;
            OptState.noTocUpdate     = NoTOCUpdateCheckBox.Checked;
            OptState.clearBackground = ClearBackgroundCheckBox.Checked;

            this.Close();
        }

        /**************************************************
            ValidateAndSet:
            Used by the ApplyButton_Click event handler to
            verify the contents of number boxes and convert
            their values to "twips", the base unit for the
            OptionsState object. If the numeric value is
            invalid, the current tab is set to the one
            containing the field with the invalid input.
            ValueString: the value in the field
            unit: the unit selected for the numeric value.
            name: the name of the field for user error messages.
            Tab: the tab that the field belongs to.
         **************************************************/
        public double ValidateAndSet(String ValueString, int unit, String name, System.Windows.Forms.TabPage Tab) {
            try {
                double value = Convert.ToDouble(ValueString);
                value = ConvertToTwips(value, unit);
                return value;
            } catch {
                System.Windows.Forms.MessageBox.Show(name + " is an invalid number!");
                TabControls.SelectedTab = Tab;
                return -1;
            }
        }

        /**************************************************
            ConvertToTwips:
            converts the given value in the given unit to
            "twips", the base unit of the OptionsState object.
            value: the numeric value to convert
            unit: the unit that the numeric value is currently in.
         **************************************************/
        public double ConvertToTwips(double value, int unit) {
            switch(unit) {
                case OptionsState.UNIT_CM: return value * 1440 / 2.54;
                case OptionsState.UNIT_IN: return value * 1440;
                case OptionsState.UNIT_PT: return value * 20;
                default: System.Windows.Forms.MessageBox.Show("No valid unit specified!"); return -1;
            }
        }

        /**************************************************
            ConvertFromTwips:
            converts the given value from twips to the requested
            unit. If no unit, select from user's locale.
            value: the numeric value in twips to convert
            unit: the unit that the numeric value should be converted to.
         **************************************************/
        public double ConvertFromTwips(double value, int unit) {
            if(unit == OptionsState.UNIT_NONE) {
                unit = LocaleUnits();
            }
            switch (unit) {
                case OptionsState.UNIT_CM: return value * 2.54 / 1440;
                case OptionsState.UNIT_IN: return value / 1440;
                case OptionsState.UNIT_PT: return value / 20;
                default: System.Windows.Forms.MessageBox.Show("No valid unit specified!"); return -1;
            }
        }

    }

    /**************************************************
        HighlightSystem:
        Objects of this class act as clojures on an event
        handler that controls highlighting fields that
        have erroneous input in them when the user attempts
        to apply the changes to the options. This class also
        handles removing highlight event handlers from
        objects that have been deactivated or corrected.
    **************************************************/
    public class HighlightSystem {

        System.Windows.Forms.Control Control;
        Color OriginalBackColor;
        System.EventHandler GotFocusEventHandler = null;

        /**************************************************
            HighlightSystem:
            Constructor for an event handler clojure.
            ControlArg: the control that will be highlighted.
         **************************************************/
        public HighlightSystem(System.Windows.Forms.Control ControlArg) {
            this.Control = ControlArg;
            Color OriginalBackColor = Control.BackColor;
            Control.BackColor = Color.Pink;
            GotFocusEventHandler = new System.EventHandler(Unhighlight);
            Control.GotFocus += GotFocusEventHandler;
        }

        /**************************************************
            Unhighlight:
            function for returning the control back to its
            original color and removing the highlight from
            its visualization.
         **************************************************/
        void Unhighlight(object sender, System.EventArgs e) {
            Control.BackColor = OriginalBackColor;
            Control.GotFocus -= GotFocusEventHandler;
        }

    }

    /**************************************************
        DrawEyeballMaker:
        This class handles drawing custom eyeball icons
        into buttons which change upon click and unfocus,
        and setting up those event handlers. These buttons
        control revealing the text inside of password fields
        which is otherwise hidden.
    **************************************************/
    public class DrawEyeballMaker {

        System.Windows.Forms.Button Button;
        System.Windows.Forms.TextBox TextBox;
        System.Windows.Forms.ToolTip ToolTip;

        /**************************************************
            DrawEyeballMaker:
            Constructor to connect a eyeball button to a
            password field textbox, also applies a tooltip
            to allow users to know what the button does without
            using it.
            Button: the eyeball button
            TextBox: the textbox that the button reveals
            ToolTip: the tooltip to display on hover
         **************************************************/
        public DrawEyeballMaker(System.Windows.Forms.Button Button, System.Windows.Forms.TextBox TextBox, System.Windows.Forms.ToolTip ToolTip) {
            this.Button = Button;
            this.TextBox = TextBox;
            this.ToolTip = ToolTip;
            Button.Paint += new System.Windows.Forms.PaintEventHandler(DrawEyeball);
        }

        /**************************************************
            DrawEyeball:
            Event handler to draw the eyeball graphic in the
            correct state of open/closed.
            sender: the eyeball button as a generic object
            pe: the paint event from which to extract the
                graphics object
         **************************************************/
        void DrawEyeball(object sender, System.Windows.Forms.PaintEventArgs pe) {

            System.Windows.Forms.Control control = sender as System.Windows.Forms.Control;

            double h = 10;
            double w = 20;
            float offx = 4;
            float offy = 4;
            double eyedist = 5;
            int r = 3;

            Graphics g = pe.Graphics;

            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;

            g.TranslateTransform(offx, offy);

            Point leftend  = new Point((int)0, (int)(h/2));
            Point open2    = new Point((int)(w / 3), (int)(h / 2 - eyedist));
            Point open3    = new Point((int)(w * 2 / 3), (int)(h / 2 - eyedist));
            Point closed2  = new Point((int)(w / 3), (int)(h / 2 + eyedist));
            Point closed3  = new Point((int)(w * 2 / 3), (int)(h / 2 + eyedist));
            Point rightend = new Point((int)w, (int)(h / 2));
            Point center = new Point((int)(w / 2), (int)(h / 2));

            Color col = Color.Black;
            if (!control.Enabled)
            {
                col = Color.Gray;
            }
            Pen pen = new Pen(col);
            if (TextBox.PasswordChar == '*') {
                Point[] curvePoints = { leftend, closed2, closed3, rightend };
                g.DrawCurve(pen, curvePoints);
                ToolTip.SetToolTip(Button, "Show");
            } else {
                Point[] curvePoints = { leftend, open2, open3, rightend };
                g.DrawCurve(pen, curvePoints);
                g.DrawEllipse(pen, (int)(w / 2 - r), (int)(h / 2 - r), (int)(2 * r - 1), (int)(2 * r - 1));
                ToolTip.SetToolTip(Button, "Hide");
            }

            // restore graphics mode to default
            g.TranslateTransform(-offx, -offy);
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.None;
        }
    }

    /**************************************************
        ActivateFieldsMaker:
        Objects of this class act as clojures on an event
        handler that handles enabling/disabling controls
        that are logically dependent on the value of a
        checkbox, installs handlers for when parent
        checkbox's value is changed.
    **************************************************/
    public class ActivateFieldsMaker {

        System.Windows.Forms.CheckBox CheckBox;
        System.Windows.Forms.Control[] controls;

        /**************************************************
            ActivateFieldsMaker:
            Constructor for ActivateFieldMaker class.
            CheckBox: the checkbox that is the parent control.
            controls: the controls to be enabled/disabled
                      dependent on the parent's value.
        **************************************************/
        public ActivateFieldsMaker(System.Windows.Forms.CheckBox CheckBox, params System.Windows.Forms.Control[] controls) {
            this.CheckBox = CheckBox;
            this.controls = controls;
        }

        /**************************************************
            ActivateFields:
            Event handler on checkbox value changes which
            enables/disables all child controls.
        **************************************************/
        public void ActivateFields(object sender, System.EventArgs e) {
            if(CheckBox.Checked) {
                for(int i = 0; i < controls.Length; i++) {
                    controls[i].Enabled = true;
                    System.Windows.Forms.TextBox TextBox = controls[i] as System.Windows.Forms.TextBox;
                    if (TextBox != null) {
                        TextBox.BackColor = default(Color);
                    }
                }
            } else {
                for (int i = 0; i < controls.Length; i++) {
                    controls[i].Enabled = false;
                    System.Windows.Forms.TextBox TextBox = controls[i] as System.Windows.Forms.TextBox;
                    if(TextBox != null) {
                        TextBox.Text = "";
                        TextBox.BackColor = default(Color);
                    }
                }
            }
        }

    }

    /*
    public class CheckBoxDisablerMaker {

        System.Windows.Forms.CheckBox CheckBox;
        System.Windows.Forms.CheckBox[] Children;

        public CheckBoxDisablerMaker(System.Windows.Forms.CheckBox CheckBox, params System.Windows.Forms.CheckBox[] Children) {
            this.CheckBox = CheckBox;
            this.Children = Children;
        }

        void CheckBoxDisabler(object sender, System.EventArgs e) {
            if(CheckBox.Checked == false) {
                for(int i = 0; i < Children.Length; i++) {
                    Children[i].Checked = false;
                    Children[i].Enabled = false;
                }
            } else {
                for (int i = 0; i < Children.Length; i++) {
                    Children[i].Enabled = true;
                }
            }
        }

    }
    */

    /**************************************************
        WireUpPasswordFieldsMaker:
        Objects of this class act as a clojure on event
        handlers dealing with password visibility in text
        fields, and the buttons which reveal them.
    **************************************************/
    public class WireUpPasswordFieldsMaker {

        System.Windows.Forms.Button Button;
        System.Windows.Forms.TextBox TextBox;

        /**************************************************
            WireUpPasswordFieldsMaker:
            Constructor for WireUpPasswordFieldsMaker
            ButtonArg: the button that reveals the password
                       text in the textbox.
            TextBoxArg: the textbox that contains the hidden
                        password text.
        **************************************************/
        public WireUpPasswordFieldsMaker(System.Windows.Forms.Button ButtonArg, System.Windows.Forms.TextBox TextBoxArg) {
            this.Button = ButtonArg;
            this.TextBox = TextBoxArg;
            Button.Click += new System.EventHandler(TogglePassword);
            Button.LostFocus += new System.EventHandler(HidePassword);
        }

        /**************************************************
            TogglePassword:
            Event handler which toggles the visibility of
            the textbox password field's text content, and
            causes the button to redraw. This event is used
            when the button is pressed.
        **************************************************/
        void TogglePassword(object sender, System.EventArgs e) {
            if(TextBox.PasswordChar == '\u0000') {
                TextBox.PasswordChar = '*';
            } else {
                TextBox.PasswordChar = '\u0000';
            }
            Button.Invalidate();
        }

        /**************************************************
            HidePassword:
            Event handler which hides the visibility of the
            textbox password field's text content, and causes
            the button to redraw. This event is used when the
            eyeball button loses focus.
        **************************************************/
        void HidePassword(object sender, System.EventArgs e) {
            TextBox.PasswordChar = '*';
            Button.Invalidate();
        }

    }

    /**************************************************
        FileEmbedStructure:
        This class handles storing and visually representing
        the list of file embeddings generated by the user
        when the PDF-A3 compliance level has been set
        under compliance in the compatability tab.
    **************************************************/
    public class FileEmbedStructure {
        ArrayList FileEmbedList;
        OptionsForm Form;
        FormBuilder Builder;
        int CurrentID;
        int MaxWidth;

        /**************************************************
            FileEmbedStructure:
            Constructor for the FileEmbedStructure class.
            Form: the data structure in which file embeddings
                  should be stored.
            Builder: the Builder that the file embeddings should be
                  visually represented in.
            MaxWidth: the total width of the containing area
                      that the list will be contained within.
        **************************************************/
        public FileEmbedStructure(OptionsForm Form, FormBuilder Builder, int MaxWidth) {
            this.Form = Form;
            this.Builder = Builder;
            FileEmbedList = new ArrayList();
            this.MaxWidth = MaxWidth;
        }

        /**************************************************
            DeactivateAll:
            Deactivates all list-related controls. Used by
            the compliance combobox upon deselection
            of the PDF-A3 compliance level.
        **************************************************/
        public void DeactivateAll() {
            for (int i = 0; i < FileEmbedList.Count; i++) {
                FileEmbedElement Elem = FileEmbedList[i] as FileEmbedElement;
                Elem.Deactivate();
            }
        }

        /**************************************************
            ActivateAll:
            Activates all list-related controls. Used by
            the compliance combobox upon selection
            of the PDF-A3 compliance level.
        **************************************************/
        public void ActivateAll() {
            for (int i = 0; i < FileEmbedList.Count; i++) {
                FileEmbedElement Elem = FileEmbedList[i] as FileEmbedElement;
                Elem.Activate();
            }
        }

        /**************************************************
            Add:
            Adds a new file embedding item to the list for
            the user to configure as necessary.
        **************************************************/
        public void Add() {
            FileEmbedList.Add(new FileEmbedElement(Form, Builder, this, CurrentID++, MaxWidth));
        }

        /**************************************************
            Clear:
            Removes all file embedding items from the list,
            used to reset after an options dialog reopening
            in order to read from the current state without
            duplicating form elements.
        **************************************************/
        public void Clear() {
            FileEmbedList.Clear();
        }

        /**************************************************
            GetHead:
            Get the top element in the file embedding list,
            that is the element we place the next element
            after.
        **************************************************/
        public FileEmbedElement GetHead() {
            return FileEmbedList[FileEmbedList.Count - 1] as FileEmbedElement;
        }

        /**************************************************
            Add:
            This Add places a preconfigured file embedding
            item in the list as prescribed by the existing
            state or initial configuration, used to restore
            the list after options dialog closing/opening
        **************************************************/
        public void Add(String path, String desc) {
            FileEmbedElement Elem = new FileEmbedElement(Form, Builder, this, CurrentID++, MaxWidth);
            FileEmbedList.Add(Elem);
            Elem.SetPath(path);
            Elem.SetDesc(desc);
        }

        /**************************************************
            GetStringsForState:
            Gets all string values from the file embedding
            items in the list and concatenates them as a
            list for visual debugging.
        **************************************************/
        public ArrayList GetStringsForState() {
            ArrayList StringList = new ArrayList();
            String StringListString = "";
            for(int i = 0; i < FileEmbedList.Count; i++) {
                FileEmbedElement Elem = FileEmbedList[i] as FileEmbedElement;
                StringList.Add(Elem.GetPath());
                StringList.Add(Elem.GetDesc());
                StringListString += Elem.GetPath() + ":" + Elem.GetDesc() + ",";
            }
            return StringList;
        }

        /**************************************************
            GetListAsStringOfIDs:
            Gets all ID field values from the list items
            for finding duplicates during debugging.
        **************************************************/
        private String GetListAsStringOfIDs() {
            String FileEmbedListString = "";
            for (int i = 0; i < FileEmbedList.Count; i++)
            {
                FileEmbedListString = FileEmbedListString + (FileEmbedList[i] as FileEmbedElement).ID.ToString() + ", ";
            }
            return FileEmbedListString;
        }

        /**************************************************
            Remove:
            Removes the file embedding item with the
            given ID.
            ID: the ID of the item to remove.
        **************************************************/
        public void Remove(int ID) {
            bool found = false;
            for(int i = 0; i < FileEmbedList.Count; i++) {
                FileEmbedElement Elem = FileEmbedList[i] as FileEmbedElement;
                if (!found) {
                    if (Elem.ID == ID) {
                        Elem.RemoveElementsFromParentControl();
                        FileEmbedList.RemoveAt(i);
                        Elem.DisposeElements();
                        found = true;
                        i--; // A new element occupies this index now, so examine it again
                    }
                } else {
                    Elem.shift(-Builder.LineHeightPlusSpacing() * 2);
                }
            }
            if(found) {
                Builder.NewLines(-2);
                System.Windows.Forms.GroupBox GroupBox = Builder.GetParent() as System.Windows.Forms.GroupBox;
                GroupBox.Size = new System.Drawing.Size(
                    GroupBox.Size.Width,
                    GroupBox.Size.Height - Builder.LineHeightPlusSpacing() * 2
                    );
                Builder.GetParent().Invalidate();
            }
        }
    }

    /**************************************************
        FileEmbedElement:
        This class contains and manages all the data and
        form controls used by a single item in the file
        embedding list.
    **************************************************/
    public class FileEmbedElement {

        public FileEmbedStructure parent;
        public int ID;
        private FormBuilder Builder;

        private System.Windows.Forms.Label PathLabel;
        private System.Windows.Forms.Button SelectButton;
        private System.Windows.Forms.TextBox DescTextBox;
        private System.Windows.Forms.Button RemoveButton;

        private const int PathLabelWidth    = 60;
        private const int SelectButtonWidth = 60;
        private const int RemoveButtonWidth = 60;

        /**************************************************
            CreateFileEmbedHeader:
            Creates the header for the file embedding list,
            including title labels and add button.
            Form: the data from which default values will be
                  added.
            Builder: The Builder to add the file embedding list to.
            MaxWidth: the width that the file embedding list's
                      items should squeeze their controls into.
        **************************************************/
        public static System.Windows.Forms.Button CreateFileEmbedHeader(OptionsForm Form, FormBuilder Builder, int MaxWidth) {
            Builder.NewLine();
            int spacing = Builder.GetHorizontalSpacing();
            Form.CreateLabel(Builder, "Files to be embedded", PathLabelWidth + spacing + SelectButtonWidth);
            Form.CreateLabel(Builder, "", MaxWidth - PathLabelWidth - SelectButtonWidth - RemoveButtonWidth - spacing * 3);
            System.Windows.Forms.Button AddButton = Form.CreateButton(Builder, "Add", RemoveButtonWidth);
            return AddButton;
        }

        /**************************************************
            Deactivate:
            Deactivates this file embedding item's controls,
            used by the FileEmbeddingList object containing
            this object to deactivate all list items when the
            compliance level is changed from PDF-A3.
        **************************************************/
        public void Deactivate() {
            PathLabel.Enabled = false;
            SelectButton.Enabled = false;
            DescTextBox.Enabled = false;
            RemoveButton.Enabled = false;
        }

        /**************************************************
            Activate:
            Activates this file embedding item's controls,
            used by the FileEmbeddingList object containing
            this object to activate all list items when the
            compliance level is changed to PDF-A3.
        **************************************************/
        public void Activate() {
            PathLabel.Enabled = true;
            SelectButton.Enabled = true;
            DescTextBox.Enabled = true;
            RemoveButton.Enabled = true;
        }

        /**************************************************
            GetPath:
            Gets the text within the path label control of
            this item, for debugging display purposes.
        **************************************************/
        public String GetPath() {
            return PathLabel.Text;
        }

        /**************************************************
            SetPath:
            Sets the text within the path label control of
            this item, used to restore values from the state
            when the options dialog is opened.
            path: the path string to set the label to.
        **************************************************/
        public void SetPath(String path) {
            PathLabel.Text = path;
        }

        /**************************************************
            GetDesc:
            Gets the text in the description textbox control
            of this item, used for debugging display purposes.
        **************************************************/
        public String GetDesc() {
            return DescTextBox.Text;
        }

        /**************************************************
            SetDesc:
            Sets the text within the description textbox
            control of this item, used to restore values
            from the state when the options dialog is opened.
            desc: the desc string to set the textbox text to.
        **************************************************/
        public void SetDesc(String desc) {
            DescTextBox.Text = desc;
        }

        /**************************************************
            FileEmbedElement:
            Constructor to create a file embedding list
            item, and set up its controls.
            Form: the form to add the item to
            Builder: the Builder that the item advances
            ID:   the id of the item for removal
            MaxWidth: the maximum width the controls can be
                      altogether.
        **************************************************/
        public FileEmbedElement(OptionsForm Form, FormBuilder Builder, FileEmbedStructure parent, int ID, int MaxWidth) {
            this.Builder = Builder;
            this.parent = parent;
            this.ID = ID;
            int spacing = Builder.GetHorizontalSpacing();

            Builder.NewLine();
            SelectButton = Form.CreateButton(Builder, "Select", SelectButtonWidth);
            PathLabel = Form.CreateLabel(Builder, "Not selected", MaxWidth - SelectButtonWidth - RemoveButtonWidth - spacing * 2);
            PathLabel.AutoSize = false;
            PathLabel.AutoEllipsis = true;
            RemoveButton = Form.CreateButton(Builder, "Remove", RemoveButtonWidth);
            Builder.NewLine();
            DescTextBox = Form.CreateTextBox(Builder, "Desc", MaxWidth, "description of the file");
            // Builder.NewLine();

            SelectButton.Click += new System.EventHandler(SelectFile);
            RemoveButton.Click += new System.EventHandler(RemoveSelf);
        }

        /**************************************************
           RemoveSelf:
           Finds self in the parent element and removes,
           correcting placement of item controls after this
           item appropriately.
        **************************************************/
        public void RemoveSelf(object sender, System.EventArgs e) {
            parent.Remove(ID);
        }

        /**************************************************
            RemoveElementsFromParentControl:
            Removes controls from parent control to reflect
            the current state of the internal list of items
            to the user.
        **************************************************/
        public void RemoveElementsFromParentControl() {
            System.Windows.Forms.Control Control = Builder.GetParent() as System.Windows.Forms.Control;
            Control.Controls.Remove(SelectButton);
            Control.Controls.Remove(PathLabel);
            Control.Controls.Remove(RemoveButton);
            Control.Controls.Remove(DescTextBox);
        }

        /**************************************************
            DisposeElements:
            Prevents memory leaks by disposing this item's
            controls when they are no longer in use.
        **************************************************/
        public void DisposeElements() {
            SelectButton.Dispose();
            PathLabel.Dispose();
            RemoveButton.Dispose();
            DescTextBox.Dispose();
        }

        /**************************************************
            shift:
            shift the physical location of the controls of
            this item to get rid of the gap left by removed
            items.
        **************************************************/
        public void shift(int amount) {
            PathLabel.Location    = new System.Drawing.Point(PathLabel.Location.X,    PathLabel.Location.Y    + amount);
            SelectButton.Location = new System.Drawing.Point(SelectButton.Location.X, SelectButton.Location.Y + amount);
            DescTextBox.Location  = new System.Drawing.Point(DescTextBox.Location.X,  DescTextBox.Location.Y  + amount);
            RemoveButton.Location = new System.Drawing.Point(RemoveButton.Location.X, RemoveButton.Location.Y + amount);
        }

        /**************************************************
            SelectFile:
            Upon clicking the select button of this item,
            open a file selection dialog and set the path to
            the value selected if a valid path was selected.
        **************************************************/
        private void SelectFile(object sender, System.EventArgs e) {
            using (OpenFileDialog FileSelector = new OpenFileDialog()) {
                FileSelector.InitialDirectory = "";
                FileSelector.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                FileSelector.FilterIndex = 2;
                FileSelector.RestoreDirectory = true;

                if (FileSelector.ShowDialog() == DialogResult.OK) {
                    PathLabel.Text = FileSelector.FileName;
                }
            }
        }

    }

    /**************************************************
        FormBuilder:
        This class places child controls and advances
        the current position within the parent control
        as a type writer Builder would do. Makes sure
        controls are placed apart from each other with
        consistent padding.
    **************************************************/
    public class FormBuilder {

        private System.Windows.Forms.Control Parent;

        private int Width, Height;
        private int HorizontalSpacing, VerticalSpacing;
        private int TopMargin, BottomMargin, LeftMargin, RightMargin;
        private int LineHeight, TabWidth;
        private int BuilderX, BuilderY;

        private int TabCount = 0;
        private int TabIndex = 0;

        /**************************************************
            FormBuilder:
            Creates an instance with the given configuration.
            There is a lot to configure here.
            Width:  the width of the parent control
            Height: the height of the parent control
            HorizontalSpacing: left/right spacing between controls
            VerticalSpacing: top/bottom spacing between controls
            TopMargin: space between top and first line of controls
            BottomMargin: space between bottom and last line of controls
            LeftMargin: space between left and first control of each line
            RightMargin: space between right and last control of each line
            LineHeight: the height of the controls in each line
            TabWidth: the horizontal length of a tab
        **************************************************/
        public FormBuilder(
            int Width, int Height,
            int HorizontalSpacing, int VerticalSpacing,
            int TopMargin, int BottomMargin, int LeftMargin, int RightMargin,
            int LineHeight, int TabWidth
            ) {
            this.Width = Width;
            this.Height = Height;
            this.HorizontalSpacing = HorizontalSpacing;
            this.VerticalSpacing = VerticalSpacing;
            this.TopMargin = TopMargin;
            this.BottomMargin = BottomMargin;
            this.LeftMargin = LeftMargin;
            this.RightMargin = RightMargin;
            this.LineHeight = LineHeight;
            this.TabWidth = TabWidth;
            ResetBuilderPosition();
        }

        /**************************************************
            GetHorizontalSpacing:
            gets the left/right spacing between controls.
        **************************************************/
        public int GetHorizontalSpacing() {
            return HorizontalSpacing;
        }

        /**************************************************
            LineHeightPlusSpacing:
            Finds the vertical position of where controls
            will be on the next line.
        **************************************************/
        public int LineHeightPlusSpacing() {
            return LineHeight + VerticalSpacing;
        }

        /**************************************************
            GetParent:
            Get the parent control that this Builder adds
            child controls to.
        **************************************************/
        public System.Windows.Forms.Control GetParent() {
            return Parent;
        }

        /**************************************************
            UsableWidth:
            Get the remaining width available after
            accounting for tab level, existing controls,
            horizontal margins, and max width of parent
            control.
        **************************************************/
        public int UsableWidth() {
            return Width - LeftMargin - RightMargin - ((TabCount+1) * TabWidth) - HorizontalSpacing * 2;
        }

        /**************************************************
            StartGroupBox:
            Create a group box and control it with another
            tabbed (indented) Builder.
            GroupBoxTitle: the title appearing in the top left
                           corner of the groupbox.
        **************************************************/
        public FormBuilder StartGroupBox(String GroupBoxTitle) {
            GroupBox StartedGroupBox = new GroupBox();
            StartedGroupBox.Text = GroupBoxTitle;
            StartedGroupBox.Location = new System.Drawing.Point(HorizontalSpacing, this.getHeightOfInternals());
            StartedGroupBox.Size = new System.Drawing.Size(Width - HorizontalSpacing * 2, 1000);
            FormBuilder GroupBoxBuilder = new FormBuilder(
                OptionsForm.WIDTH, OptionsForm.HEIGHT,
                HorizontalSpacing, VerticalSpacing, TopMargin + 5, BottomMargin,
                LeftMargin, RightMargin, LineHeight, TabWidth);
            GroupBoxBuilder.SetParent(StartedGroupBox);
            GroupBoxBuilder.Tab(1);
            return GroupBoxBuilder;
        }

        /**************************************************
            EndGroupBox:
            End a groupbox created by this FormBuilder using
            the groupbox's Builder. This updates the Builder position
            of this FormBuilder to place elements after the
            groupbox.
            EndingGroupBoxBuilder: the Builder of the groupbox that is ending.
        **************************************************/
        public void EndGroupBox(FormBuilder EndingGroupBoxBuilder) {
            System.Windows.Forms.GroupBox EndingGroupBox = EndingGroupBoxBuilder.Parent as System.Windows.Forms.GroupBox;
            EndingGroupBox.Size = new System.Drawing.Size(Width - 18, EndingGroupBoxBuilder.getHeightOfInternals());
            this.Parent.Controls.Add(EndingGroupBox);
            this.ApplyVerticalOffset(EndingGroupBoxBuilder.getHeightOfInternals() + 5);
        }

        /**************************************************
            GetHeightOfInternals:
            Gets the total height of the Builder, used for ending
            groupbox Builders and advancing the containing Builder
            vertically past the groupbox contents.
        **************************************************/
        public int getHeightOfInternals() {
            return BuilderY + LineHeight + VerticalSpacing * 2;
        }

        /**************************************************
            SetParent:
            Sets the parent control of the FormBuilder to the
            given control. The Builder will then add child
            controls to this parent control.
            Parent: the parent control to add to with this Builder.
        **************************************************/
        public void SetParent(System.Windows.Forms.Control Parent) {
            this.Parent = Parent;
            //this.Width = Parent.Size.Width;
            //this.Height = Parent.Size.Height;
            ResetBuilderPosition();
        }

        /**************************************************
            ResetBuilderPosition:
            Place the Builder at the beginning of the parent
            control (plus margins).
        **************************************************/
        private void ResetBuilderPosition() {
            BuilderX = this.LeftMargin;
            BuilderY = this.TopMargin;
        }

        /**************************************************
            Tab:
            "Tabs" (indents) the FormBuilder to be a certain
            number of tab widths to the right of the current
            position.
            TabCountAddition: how many tabs to add to the
                              current tab level.
        **************************************************/
        public void Tab(int TabCountAddition) {
            TabCount += TabCountAddition;
            ApplyTabbing();
        }

        /**************************************************
            ApplyTabbing:
            place the Builder horizontally according to the tab
            level.
        **************************************************/
        private void ApplyTabbing() {
            BuilderX = LeftMargin + TabWidth * TabCount;
        }

        /**************************************************
            NewLine:
            As a type writer performs a carriage return,
            advance the Builder vertically to the next line
            and reset the horizontal position.
        **************************************************/
        public void NewLine() {
            ApplyTabbing();
            BuilderY += LineHeight + VerticalSpacing;
        }

        /**************************************************
            NewLines:
            Just as NewLine, but skip a number of lines
            instead of just advancing to the next.
            NumLines: the number of lines to advance by
        **************************************************/
        public void NewLines(int NumLines) {
            ApplyTabbing();
            BuilderY += (LineHeight + VerticalSpacing) * NumLines;
        }

        /**************************************************
            ApplyVerticalOffset:
            Offset the vertical position of the form Builder
            VerticalOffset: the vertical offset
        **************************************************/
        public void ApplyVerticalOffset(int VerticalOffset) {
            BuilderY += VerticalOffset;
        }

        /**************************************************
            ApplyHorizontalOffset:
            Offset the horizontal position of the form Builder
            HorizontalOffset: the horizontal offset
        **************************************************/
        public void ApplyHorizontalOffset(int HorizontalOffset) {
            BuilderX += HorizontalOffset;
        }

        /**************************************************
            Add:
            Add a child control to the parent control of this
            form Builder at the form Builder's current position
            within the control.
            control: the child control to add.
            name: the name of the child control.
            ControlWidth: the width the Builder should advance to
                          move beyond the added control, or -1
                          if the width should be retrieved from
                          the length of the text in the child
                          control's name field.
        **************************************************/
        public void Add(System.Windows.Forms.Control control, String name, int ControlWidth) {

            control.Location = new System.Drawing.Point(BuilderX, BuilderY);
            // check if size should be determined by the text
            if(ControlWidth == -1) {
                ControlWidth = getTextLength(control, name);
            }
            control.Size = new System.Drawing.Size(ControlWidth, LineHeight);
            control.Name = name;
            control.TabIndex = TabIndex++;
            Parent.Controls.Add(control);

            BuilderX += ControlWidth + HorizontalSpacing;
            if(BuilderX >= Width - RightMargin) {
                NewLine();
            }
            while(TabCount >= 0 && BuilderX >= Width - RightMargin) {
                TabCount--;
                ApplyTabbing();
            }
            if(TabCount < 0) {
                throw new Exception("Error: Control does not fit!"); // TODO remove me
            }
        }

        /**************************************************
            Add:
            Make space as if a control with the given width
            were added to the parent control. Useful for
            manually spacing controls.
            ControlWidth: the width to "skip" over horizontally.
        **************************************************/
        public void Add(int ControlWidth) {

            BuilderX += ControlWidth + HorizontalSpacing;
            if (BuilderX >= Width - RightMargin) {
                NewLine();
            }
            while (TabCount >= 0 && BuilderX >= Width - RightMargin) {
                TabCount--;
                ApplyTabbing();
            }
        }

        /**************************************************
            GetTextLength:
            Finds the graphical length of the given text
            in the control's font. Used for finding the necessary
            width of a control to encompass the text as it will
            be displayed.
            control: the control that will contain the text.
            Text: the text to be contained.
        **************************************************/
        private int getTextLength(System.Windows.Forms.Control control, String Text) {
            int width = 0;
            using (Graphics g = control.CreateGraphics()) {
                SizeF size = g.MeasureString(Text, SystemFonts.DefaultFont);
                width = (int) size.Width;
            }
            return width + 5;
        }
    }

    /**************************************************
        OptionsState:
        Objects of this class contain the entire state
        of the options configuration. The object is passed
        back and forth from the options dialog and the main
        dialog to maintain the state of the options between
        changes. Has initial values according to default
        usage.
    **************************************************/
    public class OptionsState {

        // FORMATTING

        public const int UNIT_NONE = -1;
        public const int UNIT_IN = 0;
        public const int UNIT_CM = 1;
        public const int UNIT_PT = 2;

        // pdf title
        public String title = "";
        // paperkind should be a dropdown from the
        // System.Drawing.Printing.PaperKind enum
        public bool paperSizeCustom = false;
        // These two are used in the event of the above being custom
        public int paperSizeUnit = UNIT_NONE;
        public double paperSizeWidth = 12240;
        public double paperSizeHeight = 15840;
        // radio buttons for portrait/landscape
        public bool paperOrientIsPortrait = true;
        // checkbox, activates margin textboxes
        public bool setMargins = false;
        public int marginUnit = UNIT_NONE;
        public double marginLeft = 0, marginRight = 0, marginTop = 0, marginBottom = 0;
        // checkbox
        public bool expandWidth = false;
        // checkbox
        public bool omitLastEmptyPage = true;
        // checkbox, activates dropdown for type, textfields for width and
        // space, and dropdown/color picker for color
        public bool hasBorder = false;
        public int borderType = Wpn.BRDRTYPE_DBL;
        public int borderWidth = 30;
        public int borderSpaceUnit = UNIT_NONE;
        public int borderSpace = 720;
        public Color borderColor = Color.Red;

        // checkbox
        public bool shrinkImagesToFit = false, exactTextPlacement = true;
        public bool convertComboBox = true;

        // checkbox, activates textfields and radios
        public bool printPageNumbers = false;
        public String beforeText = "[";
        public String midText = "of";
        public String afterText = "]";
        public int distanceFromEdgeUnit = UNIT_NONE;
        public int distanceFromEdge = 360;
        public int verticalAlignment = Wpn.WPREP_BOT;
        public int horizontalAlignment = Wpn.WPREP_CENTER;

        // SECURITY SUBCATEGORY

        // checkbox, activates textfield, same for both
        public bool hasOwnerPassword = false;
        public String ownerPassword = "";
        public bool hasUserPassword = false;
        public String userPassword = "";

        // checkbox
        public bool usesEncryptionAES128 = false;

        // permissions, checkboxes
        public bool permPrint = false;
        public bool permCopy = false;
        public bool permModify = false;

        // QUALITY

        // image quality, checkbox, activates dropdown or radio buttons
        public bool useOrigJpg = false;
        public int pictQuality = 3;

        // checkbox
        public bool emfAsBmp = false;

        // FILE SIZE

        // checkbox
        public bool compressText = true;

        // MISC SUBCATEGORY

        // checkbox
        public bool inWebServer = false;
        public bool doCaching = false;
        public bool isolateUnicode = false;
        public bool hideTracking = false;
        public bool noTocUpdate = false;
        public bool clearBackground = true;
        public bool hideComments = false;

        // COMPATIBILITY

        // checkbox
        public bool embedFonts = true;
        // checkbox
        public bool legacySectionProperties = false;
        // checkbox
        public bool taggedPdf = false;
        // radio buttons
        public const int CMPL_NONE = 0;
        public const int CMPL_PDFA1B = 1;
        public const int CMPL_PDFA1 = 2;
        public const int CMPL_PDFA2B = 3;
        public const int CMPL_PDFUA = 4;
        public const int CMPL_PDFA3 = 5;
        public int complianceLevel = CMPL_NONE;
        // expandable list of pairs of textfields, filename and description
        public ArrayList embedFiles = new ArrayList();

        // PRINTING

        // checkbox
        public bool noScaling = false, duplexShort = false, duplexLong = false;

        /**************************************************
            OptionsState:
            Create a state object holding the initial values
            of the options configuration's state.
        **************************************************/
        public OptionsState() { }

    }
}
